<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonctions de génération des menus déroulants
    require ("menus_deroulants.php");

    // fonction de traduction d'un fsurf
    require ("gen_anafsurf.php");


    // Constantes
    require ("dirsite.php");
    define ('PAGE', "anafsurf");


    // sélectionner la langue de l'interface utilisateur
    $lg_util = choix_langue ();

    // traitement de la page de traduction d'une forme de surface
    $ficpage = DIRPAGE_ML."/".PAGE.".html";

    // si la page cherchée n'existe pas
    if (! file_exists ($ficpage))
    {
        // erreur fatale
        echo msg_chaine ("MANQUE_PAGE", PAGE);
        return;
    }

    // ouvrir le ficher contenant la page à afficher
    $descfic = fopen ($ficpage, "r");

    // si ouverture réussie
    if ($descfic)
    {
        // copier le début de la page en le corrigeant
        cop_debpage ($descfic);

        // copier jusqu'au champ caché lpgrec et l'initialiser
        copmaj ($descfic, "XXXLGPREC", $_POST ['langue']);

        // recopie jusqu'à la liste des langues sources
        copie_jusque_option ($descfic);

        // générer le menu déroulant des langues sources
        gen_langues_dispo ($_POST ['langue'], "a", $lg_util);

        // recopie jusqu'à la liste des paires de langues
        copie_jusque_option ($descfic);

        // si langue source choisie
        if (isset ($_POST ['langue']) && $_POST ['langue'] != "")
        {
            // générer le menu déroulant avec les paires disponibles pour cette langue
            gen_liste_paires ($_POST ['langue'], $_POST ['lgprec'], $_POST ['paire']);
        }
        // sinon laisser le champ vide

        // récupérer la forme de surface en remplaçant les ~u par ŭ pour l'esperanto
        $fsurf = str_replace ("~u", "ŭ", $_POST ['fsurf']);

        // copier jusqu'à la zone de saisie de la forme
        // de surface qui est remplacée par sa valeur
        copmaj ($descfic, "XXXFSURF", $fsurf);

        // copier jusqu'à la zone d'affichage du résultat de l'analyse
        copie_jusque_chaine ($descfic, "XXXRESULT");

        // si appui sur le bouton "Analyser"
        if (isset ($_POST ['analyse']))
            // générer le résultat de l'analyse
            gen_anafsurf ($_POST ['paire'], $fsurf, $lg_util);

        // terminer la page HTML
        copie_jusque_fin ($descfic);

        // page recopiée, on n'a plus besoin du fichier html
        fclose ($descfic);
    }
?>
