<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonctions d'affichage de l'entête des pages de documentation
    require ("gen_lg_menu.php");

    // Constantes
    require ("dirsite.php");
    require ("defaut_textarea.php");
    define ('PAGE', "cookies");


    // retourne la valeur d'un cookie ou &nbsp; pour affichage

    function affcookie ($cookie)
    {
        // si le cookie est défini
        if (isset ($_COOKIE [$cookie]))
            // récupérer sa valeur
            $valcookie = $_COOKIE [$cookie];
        // sinon
        else
            // chaine vide
            $valcookie = "";

        // retourner le résultat
        if ($valcookie != "")
            return $valcookie;
        else
            return "&nbsp;";  // pour un affichage correct dans une table
    }



    // sélectionner la langue de l'interface utilisateur
    $langue = choix_langue ();

    // page à afficher
    $page = PAGE;
    $ficpage = DIRPAGES."/".$langue."/".$page.".html";

    // si la page cherchée n'existe pas
    if (! file_exists ($ficpage))
    {
        // essayer de la remplacer par la page d'erreur
        if (file_exists (MANQUE_PAGE))
            $ficpage = MANQUE_PAGE;
        else
        {
            // erreur fatale
            echo msg_chaine ("MANQUE_PAGE", $page);
            return;
        }
    }

    // ouvrir le ficher contenant la page à afficher
    $descfic = fopen ($ficpage, "r");

    // si ouverture réussie
    if ($descfic)
    {
        // copier le début de la page en le corrigeant
        cop_debpage ($descfic);

        // insérer le bandeau des langues
        ajout_langues ();

        // insérer le menu
        ajout_menu ();

        // le menu est à gauche sur la hauteur restante
        echo "    <div id=\"contenu\">\n";

        // si la page à afficher a été trouvée
        if ($ficpage != MANQUE_PAGE)
        {
            // générer la page en remplaçant les cookies par leur valeur
            copmaj ($descfic, "XXXLG_UTIL",   affcookie ("lg_util"));
            copmaj ($descfic, "XXXFORMAT",    affcookie ("format"));
            copmaj ($descfic, "XXXSUPPRSIG",  affcookie ("suppr_sig"));
            copmaj ($descfic, "XXXMODE_SEL",  affcookie ("mode_sel"));
            copmaj ($descfic, "XXXTRAD_DIR",  affcookie ("trad_directe"));
            copmaj ($descfic, "XXXLG_SOURCE", affcookie ("lg_source"));
            copmaj ($descfic, "XXXLG_CIBLE",  affcookie ("lg_cible"));
            copmaj ($descfic, "XXXLG_PIVOT",  affcookie ("lg_pivot"));
            copmaj ($descfic, "XXXSENSTRAD1", affcookie ("senstrad1"));
            copmaj ($descfic, "XXXSENSTRAD2", affcookie ("senstrad2"));
            copmaj ($descfic, "XXXVISIBIL",   affcookie ("visib_lg_url"));
            copmaj ($descfic, "XXXCLE_NAVIG", affcookie ("cle_navig"));
            copmaj ($descfic, "XXXURL",       affcookie ("url"));
            copmaj ($descfic, "XXXDISP_TRADT", affcookie ("dispo_tradtxt"));
            copmaj ($descfic, "XXXDISP_TRADW", affcookie ("dispo_tradweb"));
            copmaj ($descfic, "XXXTAIL_AUTO", affcookie ("taille_auto"));
            copmaj ($descfic, "XXXLARGEUR",   affcookie ("largeur"));
            copmaj ($descfic, "XXXHAUTEUR",   affcookie ("hauteur"));
            copmaj ($descfic, "XXXAJUST-H",   affcookie ("ajust_h"));
            copmaj ($descfic, "XXXAJUST-V",   affcookie ("ajust_v"));
            copmaj2($descfic, "XXXMINLIG", "XXXMAXLIG",  MIN_LIGNES,  MAX_LIGNES);
            copmaj ($descfic, "XXXLIG_SAIS",  affcookie ("lig_saisie"));
            copmaj2($descfic, "XXXMINCOL", "XXXMAXCOL",  MIN_COLONS,  MAX_COLONS);
            copmaj ($descfic, "XXXCOL_SAIS",  affcookie ("col_saisie"));
            copmaj2($descfic, "XXXMINURL", "XXXMAXURL",  MIN_LGURL,  MAX_LGURL);
            copmaj ($descfic, "XXXLG_URL",    affcookie ("lgmax_url"));
        }
        // sinon
        else
            // message d'erreur en bas de la page de remplacement
            copmaj ($descfic, "MM_MANQUE_PAGE", msg_chaine ("MANQUE_PAGE", PAGE));

        // copier le reste du corps de la page
        copie_jusque_chaine ($descfic, "</body>");

        // fin de la section et de la page
        echo "    </div>\n";
        echo "</body>\n";

        // copier la fin de la page HTML
        copie_jusque_fin ($descfic);

        // page recopiée, on n'a plus besoin du fichier html
        fclose ($descfic);
    }
?>
