<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonctions d'affichage de l'entête des pages de documentation
    require ("gen_lg_menu.php");

    // Constantes
    require ("dirsite.php");
    require ("defaut_textarea.php");

    define ('PAGE', "corrige_taille_auto");
    define ('ECHEC_MES', "echec_mesure_taille");
    define ('HAUTEUR_CRITIQUE', 570);


    // génération éventuelle d'un bouton pour modifier un coefficient de correction

    function genbouton ($coef, $sens, $apres_depl)
    {
        // calculer la valeur absolue du coefficient et le symbole
        // de déplacement à afficher danbs le bouton en HTML
        if ($coef < 0)
        {
            $abscoef = - $coef;
            $symbole = "&lt;";
        }
        else
        {
            $abscoef = $coef;
            $symbole = "&gt;";
        }

        // calculer le nombre de symboles de déplacement à afficher dans le bouton
        $nbsymb = 1;

        while ($abscoef > 1)
        {
            $nbsymb ++;
            $abscoef = $abscoef / 3;
        }

        // calcul de l'effet d'un nouveau bouton produisant un déplacement 3 fois moindre
        $test_limite = $apres_depl + ($coef / 3);

        // pour une bonne présentation du source HTML de la page générée
        echo "                ";

        // s'il est utile d'afficher le bouton demandé
        if (-20 < $test_limite && $test_limite < 20)
        {
            // le faire
            echo "<td><button type=\"submit\" name=\"ajust_";
            echo $sens."\" value=\"".$coef."\">";

            while ($nbsymb --)
                echo $symbole;

            echo "</button></td>\n";
        }
        // sinon
        else
        {
            // déterminer la largeur qu'il aurait pris
            $largeur = 12 * ($nbsymb) + 24;

            // générer un espace vide de cette largeur
            echo "<td width=\"".$largeur."\">&nbsp;</td>\n";
        }
    }



    // début du programme principal

    // si les dimensions de la fenêtre doivent être mesurées
    if (isset ($_GET ['mesure']))
    {
        // afficher d'abord la page qui fait la mesure
        $page = DIRPAGE_ML."/recup_taille_fen.html";

        if (file_exists ($page))
            readfile ($page);
        else
            echo msg_chaine ("MANQUE_PAGE", "recup_taille_fen");

        // la page normale sera affichée ensuite pas une redirection
        return;
    }

    // initialisation

    if (isset ($_COOKIE ['ajust_v']))
        $ajust_v = $_COOKIE ['ajust_v'];
    else
        $ajust_v = 0;

    if (isset ($_COOKIE ['ajust_h']))
        $ajust_h = $_COOKIE ['ajust_h'];
    else
        $ajust_h = 0;


    // si modification du coefficient d'ajustement de la hauteur
    if (isset ($_POST ['ajust_v']))
    {
        // calculer sa nouvelle valeur
        $ajust_v = $ajust_v + $_POST ['ajust_v'];

        // la corriger si hors de l'intervalle ± 20 %
        if ($ajust_v < -20)
            $ajust_v = -20;
        else if ($ajust_v > 20)
            $ajust_v = 20;

        // mémoriser la nouvelle valeur dans le cookie
        setcookie ("ajust_v", $ajust_v, 0);
    }
    // sinon si modification du coefficient d'ajustement de la largeur
    else if (isset ($_POST ['ajust_h']))
    {
        // calculer sa nouvelle valeur
        $ajust_h = $ajust_h + $_POST ['ajust_h'];

        // la corriger si hors de l'intervalle ± 20 %
        if ($ajust_h < -20)
            $ajust_h = -20;
        else if ($ajust_h > 20)
            $ajust_h = 20;

        // mémoriser la nouvelle valeur dans le cookie
        setcookie ("ajust_h", $ajust_h, 0);
    }
    // sinon si initalisation du coefficient d'ajustement de la hauteur
    else if (isset ($_POST ['init_v']))
    {
        // le faire
        $ajust_v = 0;
        setcookie ("ajust_v", 0, 0);
    }
    // sinon si initalisation du coefficient d'ajustement de la largeur
    else if (isset ($_POST ['init_h']))
    {
        // le faire
        $ajust_h = 0;
        setcookie ("ajust_h", 0, 0);
    }

    // sélectionner la langue de l'interface utilisateur
    $langue = choix_langue ();

    // si les dimensions de la fenêtre ont pu être mesurées
    if (isset ($_COOKIE ['largeur']) && isset ($_COOKIE ['hauteur']))
    {
        // afficher la page normale
        $page = PAGE;

        // fabriquer le chemin d'accès de la page à afficher
        $ficpage = DIRPAGES."/".$langue."/".$page.".html";
    }
    // sinon page d'erreur
    else
    {
        $page = ECHEC_MES;
        $ficpage = DIRPAGE_ML."/".$page.".html";
    }


    // si la page cherchée n'existe pas
    if (! file_exists ($ficpage))
    {
        // essayer de la remplacer par la page d'erreur
        if (file_exists (MANQUE_PAGE))
            $ficpage = MANQUE_PAGE;
        else
        {
            // erreur fatale
            echo msg_chaine ("MANQUE_PAGE", $page);
            return;
        }
    }

    // ouvrir le ficher contenant la page à afficher
    $descfic = fopen ($ficpage, "r");

    // si ouverture réussie
    if ($descfic)
    {
        // copier le début de la page en le corrigeant
        cop_debpage ($descfic);

        // si on traite la page d'ajustement des corrections
        if (strpos ($ficpage, PAGE) > 0)
        {
            // récupérer la hauteur réelle de la fenêtre
            $hauteur = $_COOKIE ['hauteur'];

            // la corriger
            $nbpix = $hauteur * (1 + ($ajust_v / 100));

            // calculer le nombre de lignes de la barre textarea
            $nblig = ($nbpix - 65) / PIX_LIGNE;

            // récupérer la largeur de la fenêtre et la corriger
            $nbpix = $_COOKIE ['largeur'] * (1 + ($ajust_h / 100));

            // calculer le nombre de colonnes de la barre textarea
            $nbcol = ($nbpix - 30) / PIX_COLONNE;

            // arrondis par défaut si nécessaire
            $nblig = floor ($nblig);
            $nbcol = floor ($nbcol);

            // recopier le début en mettant à la la largeur et la hauteur des textarea
            copmaj ($descfic, "XXXCOLS", $nbcol);
            copmaj ($descfic, "XXXLIGS", $nblig);

            // si la hauteur de la fenêtre est faible
            if ($hauteur < HAUTEUR_CRITIQUE)
            {
                // recopier le texte avec moins de lignes blanches
                copie_jusque_chaine ($descfic, " <br>");
                copie_jusque_chaine ($descfic, " <br>");
            }

            // copier jusqu'à la ligne des boutons de réglage de la correction en largeur
            copie_jusque_chaine ($descfic, "<tr>", 1);

            // générer les boutons permettant de diminuer la largeur
            genbouton ("-9", "h", $ajust_h);
            genbouton ("-3", "h", $ajust_h);
            genbouton ("-1", "h", $ajust_h);

            // lire et afficher la ligne de réinitialisation de la largeur
            echo fgets ($descfic, LGMAX);

            // générer les boutons permettant d'augmenter la largeur
            genbouton ("1", "h", $ajust_h);
            genbouton ("3", "h", $ajust_h);
            genbouton ("9", "h", $ajust_h);

            // si la hauteur de la fenêtre est faible
            if ($hauteur < HAUTEUR_CRITIQUE)
                // recopier le texte avec une ligne blanche de moins
                copie_jusque_chaine ($descfic, " <br>");

            // copier jusqu'à la ligne des boutons de réglage de la correction en hauteur
            copie_jusque_chaine ($descfic, "<tr>", 1);

            // générer les boutons permettant de diminuer la hauteur
            genbouton ("-9", "v", $ajust_v);
            genbouton ("-3", "v", $ajust_v);
            genbouton ("-1", "v", $ajust_v);

            // lire et afficher la ligne de réinitialisation de la hauteur
            echo fgets ($descfic, LGMAX);

            // générer les boutons permettant d'augmenter la hauteur
            genbouton ("1", "v", $ajust_v);
            genbouton ("3", "v", $ajust_v);
            genbouton ("9", "v", $ajust_v);

            // si la hauteur de la fenêtre est faible
            if ($hauteur < HAUTEUR_CRITIQUE)
                // recopier les liens avec une ligne blanche de moins
                copie_jusque_chaine ($descfic, " <br>");
        }
        // sinon
        else
        {
            // insérer le bandeau des langues
            ajout_langues ();

            // insérer le menu
            ajout_menu ();

            // le menu est à gauche sur la hauteur restante
            echo "    <div id=\"contenu\">\n";

            // si nécessaire, afficher la page indiquant le nom de la page qui manque
            if ($ficpage == MANQUE_PAGE)
                copmaj ($descfic, "MM_MANQUE_PAGE", msg_chaine ("MANQUE_PAGE", $page));

            // copier le reste du corps de la page
            copie_jusque_chaine ($descfic, "</body>");

            // fin de la section et de la page
            echo "    </div>\n";
            echo "</body>\n";
        }

        // copier la fin de la page HTML
        copie_jusque_fin ($descfic);

        // page recopiée, on n'a plus besoin du fichier html
        fclose ($descfic);
    }
?>
