<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonctions d'affichage de l'entête des pages de documentation
    require ("gen_lg_menu.php");

    // Constantes
    require ("dirsite.php");
    require ("defaut_textarea.php");
    define ('PAGE', "param_get");


    // sélectionner la langue de l'interface utilisateur
    $langue = choix_langue ();

    // page à afficher
    $page = PAGE;
    $ficpage = DIRPAGES."/".$langue."/".$page.".html";

    // si la page cherchée n'existe pas
    if (! file_exists ($ficpage))
    {
        // essayer de la remplacer par la page d'erreur
        if (file_exists (MANQUE_PAGE))
            $ficpage = MANQUE_PAGE;
        else
        {
            // erreur fatale
            echo msg_chaine ("MANQUE_PAGE", $page);
            return;
        }
    }

    // ouvrir le ficher contenant la page à afficher
    $descfic = fopen ($ficpage, "r");

    // si ouverture réussie
    if ($descfic)
    {
        // copier le début de la page en le corrigeant
        cop_debpage ($descfic);

        // insérer le bandeau des langues
        ajout_langues ();

        // insérer le menu
        ajout_menu ();

        // le menu est à gauche sur la hauteur restante
        echo "    <div id=\"contenu\">\n";

        // si la page à afficher a été trouvée
        if ($ficpage != MANQUE_PAGE)
        {
            // générer la page en remplaçant les cookies par leur valeur
            copmaj2 ($descfic, "XXXMINLIG", "XXXMAXLIG",  MIN_LIGNES,  MAX_LIGNES);
            copmaj2 ($descfic, "XXXMINCOL", "XXXMAXCOL",  MIN_COLONS,  MAX_COLONS);
            copmaj2 ($descfic, "XXXMINURL", "XXXMAXURL",  MIN_LGURL,  MAX_LGURL);
        }
        // sinon
        else
            // message d'erreur en bas de la page de remplacement
            copmaj ($descfic, "MM_MANQUE_PAGE", msg_chaine ("MANQUE_PAGE", PAGE));

        // copier le reste du corps de la page
        copie_jusque_chaine ($descfic, "</body>");

        // fin de la section et de la page
        echo "    </div>\n";
        echo "</body>\n";

        // copier la fin de la page HTML
        copie_jusque_fin ($descfic);

        // page recopiée, on n'a plus besoin du fichier html
        fclose ($descfic);
    }
?>
