<?php
    // analyse d'une forme de surface et affichage du résultat

    function gen_anafsurf ($paire, $fsurf, $lg_util)
    {
        // vérifier si 1er paramètre correct
        if ($paire == "")
        {
            if ($_POST ['langue'] == "")
                // Choisissez la langue source d'abord
                echo "      ".message ("CHOIX_LG_SOURCE")."<br>\n";
            else
                // Choisissez une paire de langues d'abord
                echo "      ".message ("CHOIX_PAIRE")."<br>\n";

            return;
        }
        // vérifier si 2ème paramètre correct
        if ($fsurf == "")
        {
            // Saisir la forme de surface d'abord
            echo "      ".message ("CHOIX_FSURF")."<br>\n";
            return;
        }

        $commande = "shells/anafsurf $paire \"$fsurf\" $lg_util 2>&1";

        // effectuer l'analyse
        exec ($commande, $resultat);

        // récupérer le nombre d'analyses trouvées
        $nb_lignes = count ($resultat);

        // si on a pu analyser la forme de surface
        if ($nb_lignes)
        {
            echo "      <table cellpadding=10 border=1>\n";
            echo "        <tr align=center><td>";
            echo message ("LEMME");
            echo "</td><td>";
            echo message ("TYPE_MOT");
            echo "</td><td>";
            echo message ("ATTRIBUTS");
            echo "</td></tr>\n";

            // affichage des différentes analyses
            for ($i = 0; $i < $nb_lignes; $i++)
            {
                $ligne = $resultat [$i];

                $finlemme = strpos ($ligne, "<");
                $lemme = substr ($ligne, 0, $finlemme);

                $ligne = substr ($ligne, $finlemme + 1);
                $fintype = strpos ($ligne, ">");
                $typemot = substr ($ligne, 0, $fintype);

                $attributs = substr ($ligne, $fintype + 2);

                if (strlen ($attributs))
                {
                    $attributs = str_replace ("><", ", ", $attributs);
                    $attributs = str_replace (">", "", $attributs);
                }
                else
                    $attributs = "&nbsp;";

                echo "        <tr>";
                echo "<td>$lemme</td><td>$typemot</td><td>$attributs</td></tr>\n";
            }

            echo "      </table>\n";
        }
        // sinon message d'erreur
        else
            // Forme de surface non trouvée
            echo "      ".message ("FSURF_INCONNUE")."<br>\n";
    }
?>
