<?php
    // Constante
    define ('LGMAX', 200);   // longueur maximale des lignes des fichiers

    // variables globales
    $script = "";



    // récupération du script d'appel de la page auquel
    // on rajoute le paramètre lang non initialisé

    function mem_script ()
    {
        global $script;

        // récupérer le chemin d'accès à la page
        $uri = $_SERVER ['REQUEST_URI'];

        // si pas de nom de fichier php
        if (substr ($uri, strlen ($uri) - 1) == "/")
            // le script est celui de la page d'accueil
            $script = "index.php";
        // sinon
        else
            // extraire le script d'appel de la page
            $script = basename ($uri);

        // rajouter le paramètre lang non initialisé

        // si paramètre lang présent
        if (strpos ($script, "lang="))
            // enlever la valeur de la langue
            $script = substr ($script, 0, strpos ($script, "lang=") + 5);
        // sinon si script avec au moins un paramètre
        else if (strpos ($script, "?"))
            // rajouter lang comme paramètre supplémentaire
            $script = $script."&lang=";
        // sinon (script sans paramètre)
        else
            // rajouter lang comme premier paramètre
            $script = $script."?lang=";
    }


    // insertion d'un lien vers une langue de l'interface utilisateur

    function ajout_langue ($nom, $code)
    {
        // accès aux variables $langue et $page du programme principal
        global $langue;
        global $ficpage;
        global $script;

        echo "      ";

        // si la langue a générer est la langue courante
        if ($code == $langue)
            // l'afficher en orange, mais sans lien
            echo "<font color=#FF8000>$nom</font>";
        // sinon
        else
        {
            // chercher la page dans la langue concernée
            $ficpage2 = str_replace ("/".$langue."/", "/".$code."/", $ficpage);

            // si la page existe dans cette langue
            if (file_exists ($ficpage2))
                // générer un lien
                echo "<a href=\"$script$code\">$nom</a>";
            // sinon
            else
                // afficher la langue sans lien hypertexte
                echo $nom;
        }

        // espace par rapport à la langue suivante éventuelle
        echo " &nbsp; &nbsp;\n";
    }


    // insertion de liens vers les langues de l'interface utilisateur

    function ajout_langues ()
    {
        // récupération du script d'appel de la page
        mem_script ();

        // le bandeau des langues est en haut et centré
        echo "    <div id=\"langues\">\n";

        // ajout des langues
        ajout_langue ("Catalan",   "cat");
        ajout_langue ("English",   "eng");
        ajout_langue ("Español",   "spa");
        ajout_langue ("Esperanto", "epo");
        ajout_langue ("Français",  "fra");
        ajout_langue ("Italiano",  "ita");
        ajout_langue ("Portuguais","por");

        // fin de la section
        echo "    </div>\n";
    }


    // fonction permettant d'insérer les liens rapides en haut de page

    function ajout_menu ()
    {
        // accès à la variable $langue page du programme principal
        global $langue;


        // si la page des liens rapides n'existe pas
        if (! file_exists (MENU))
        {
            // message d'erreur
            echo msg_chaine ("MANQUE_PAGE", MENU);
            return;
        }

        // extraire le script d'appel de la page
        $script = basename ($_SERVER ['REQUEST_URI']);

        // si paramètre passé à PHP, le supprimer
        $param = strpos ($script, "?");

        if ($param)
            $script = substr ($script, 0, $param);

        // ouvrir le ficher contenant le morceau de page à afficher
        $descfic = fopen (MENU, "r");

        // si ouverture réussie
        if ($descfic)
        {
            // le menu est à gauche sur la hauteur restante
            echo "    <div id=\"menu\">\n";
            echo "      <br>\n      <br>\n";

            // si la langue demandée est supportée
            if (file_exists (DIRMSG."/".$langue))
                // lire une ligne du menu
                $ligne = fgets ($descfic, LGMAX);

            // tant que non fin de fichier (une ligne a été lue)
            while ($ligne)
            {
                // indentation
                echo "      ";

                // chercher la séparation entre les 2 champs de la ligne
                $posblanc = strpos ($ligne, " ");

                // si séparation trouvée
                if ($posblanc)
                {
                    // recupérer le mnémonique
                    $message = substr ($ligne, 0, $posblanc);

                    // le remplacer par sa signification dans la langue de l'utilisateur
                    $texte = message (substr ($message, 3));

                    // récupérer le lien
                    $lien = trim (substr ($ligne, $posblanc));

                    // déterminer si on est déjà sur le lien à afficher
		    // c'est soit un script PHP spécifique soit index.php?page=...
                    if (isset ($_GET ['page']))
		        $danslien = (strpos ($lien, $_GET ['page']) > 0);
		    else
                        $danslien = ($lien == $script);

                    // si on est déjà sur ce lien
                    if ($danslien)
                        // afficher la ligne
                        echo "<font color=\"#FF8000\"><b>".$texte."</b></font>";
                    // sinon
                    else
                        // afficher le lien
                        echo "<a href=\"".$lien."\">".$texte."</a>";
                }

                // sauts de ligne
                echo "<br>\n      <br>\n";

                // passer à la ligne suivante
                $ligne = fgets ($descfic, LGMAX);
            }

            // menu recopié, on n'a plus besoin du fichier
            fclose ($descfic);

            // fin de la section
            echo "    </div>\n";
        }
    }
?>
