<?php
    // affichage d'un coté de la traduction du lemme

    function aff_cote ($cote)
    {
        $finlemme = strpos ($cote, "<");
        $lemme = substr ($cote, 0, $finlemme);
        $suite = substr ($cote, $finlemme + 1);

        $fintype = strpos ($suite, ">");
        $type    = substr ($suite, 0, $fintype);
        $attributs = substr ($suite, $fintype + 2);

        if (strlen ($attributs))
        {
            $attributs = str_replace ("><", ", ", $attributs);
            $attributs = str_replace (">", "", $attributs);
        }
        else
            $attributs = "&nbsp;";

        echo "          <td>$lemme</td><td>$type</td><td>$attributs</td>\n";
    }



    // affichage du sens de traduction du lemme

    function aff_sens ($sens)
    {
        echo "          <td align=center>";

        if ($sens != '>')
            echo "&lt;=";
        else
            echo "==";

        if ($sens != '<')
            echo "&gt;";
        else
            echo "=";

        echo "</td>\n";
    }




    // traduction d'un lemme et affichage du résultat

    function gen_tradlemme ($langue_source, $langue_cible, $lemme, $lg_util)
    {
        // vérifier si 1er paramètre correct
        if ($langue_source == "")
        {
            // Choisissez la langue source d'abord
            echo "      ".message ("CHOIX_LG_SOURCE")."<br>\n";
            return;
        }
        // vérifier si 2ème paramètre correct
        if ($langue_cible == "")
        {
            // Choisissez la langue cible d'abord
            echo "      ".message ("CHOIX_LG_CIBLE")."<br>\n";
            return;
        }
        // vérifier si 3ème paramètre correct
        if ($lemme == "")
        {
            // Saisir le lemme d'abord
            echo "      ".message ("CHOIX_LEMME")."<br>\n";
            return;
        }

        // préparer la commande à exécuter
        $commande = "shells/tradlemme $langue_source $langue_cible \"$lemme\" $lg_util 2>&1";

        // la lancer
        exec ($commande, $resultat);

        // récupérer le nombre de traductions trouvées
        $nb_lignes = count ($resultat);

        // si on a obtenu des traductions
        if ($nb_lignes)
        {
            echo "      <table cellpadding=10 border=1>\n";
            echo "        <tr align=center>\n";
            echo "          <td>";
            echo message ("LEMME_SOURCE");
            echo "</td><td>";
            echo message ("TYPE_MOT");
            echo "</td><td>";
            echo message ("ATTRIBUTS");
            echo "</td><td>";
            echo message ("SENS");
            echo "</td>\n          <td>";
            echo message ("LEMME_TRADUIT");
            echo "</td><td>";
            echo message ("TYPE_MOT");
            echo "</td><td>";
            echo message ("ATTRIBUTS");
            echo "</td>\n";
            echo "        </tr>\n";

            // affichage des différentes traductions
            for ($i = 0; $i < $nb_lignes; $i++)
            {
                $ligne = $resultat [$i];

                $sepsens = strpos ($ligne, ":");

                $gauche = substr ($ligne, 0, $sepsens);
                $sens   = substr ($ligne, $sepsens + 1, 1);
                $droite = substr ($ligne, $sepsens + 3);

                echo "        <tr>\n";

                aff_cote ($gauche);
                aff_sens ($sens);
                aff_cote ($droite);

                echo "        </tr>\n";
            }

            echo "      </table>\n";
        }
        // sinon message d'erreur
        else
            // Lemme non trouvé dans le dictionnaire bilingue
            echo "      ".message ("LEMME_INCONNU")."<br>\n";
    }
?>
