<?php
    // fonctions d'affichage de portions de pages HTML
    require_once ("acces_page.php");

    // fonctions de génération des menus déroulants
    require_once ("menus_deroulants.php");

    // Constantes
    require_once ("dirsite.php");
    define ('PAGESENS', "choixsenstrad");



    // génère le morceau de page permettant de définir les sens de traduction

    function genpage_choixsenstrad ($senstrad1, $senstrad2, $suppr_sig, $format)
    {
        // déterminer le suffixe de la page à afficher

        // pour une traduction de texte
        if ($format != "web")
        {
            $bandeau = substr ($_COOKIE ['dispo_tradtxt'], 0, 1);

            // bandeau de sélection horizontal ou vertical ?
            if ($bandeau == "<" || $bandeau == ">")
                $suf = "v";
            else if ($bandeau == "^" || $bandeau == "v")
                $suf = "h1";
            else
                $suf = "h2";
        }
        // pour traduire une page web
        else
        {
            $bandeau = substr ($_COOKIE ['dispo_tradweb'], 0, 1);

            // bandeau de sélection horizontal ou vertical ?
            if ($bandeau == "<" || $bandeau == ">")
                $suf = "v";
            else
                $suf = "h";

            $suf = $suf."_pweb";
        }

        // fabriquer le chemin d'accès à la page à afficher
        $ficpage = DIRPAGE_ML."/".PAGESENS."_".$suf.".html";

        // si la page cherchée n'existe pas
        if (! file_exists ($ficpage))
        {
            // erreur fatale
            echo msg_chaine ("MANQUE_PAGE", PAGESENS."_".$suf);
            return;
        }

        // ouvrir le ficher contenant la page à afficher
        $descfic = fopen ($ficpage, "r");

        // si ouverture réussie
        if ($descfic)
        {
            // recopie jusqu'a la zone de saisie du premier sens de traduction
            copmaj ($descfic, "XXXSENSTRAD1", $senstrad1);

            // recopie jusqu'a la zone de saisie du deuxième sens de traduction
            copmaj ($descfic, "XXXSENSTRAD2", $senstrad2);

            // si traduction d'une paghe web
            if ($format == "web")
            {
                // déterminer le sens du bouton de masquage du choix des langues
                if ($_COOKIE ['dispo_tradweb'] == "v")
                    $sens = "b";
                else
                    $sens = "h";

                // affichage de ce bouton
                copmaj ($descfic, "XXXSENS", $sens);
            }

            // récupérer la valeur de la case indiquant si on supprime les = @ #
            if ($suppr_sig != "N")
                // convertir l'information en HTML
                $checked = "checked";
            else
                $checked = "";

            // recopie jusqu'a la case à cocher indiquant la traduction directe
            // initialisation de cette case
            copmaj ($descfic, "XXXCHECK", $checked);

            // si on veut traduire un texte
            if ($format != "web")
            {
                // recopie jusqu'au choix du format des données
                copie_jusque_option ($descfic);

                // générer le menu déroulant de choix d'un format
                gen_formats_texte ($format);
            }

            // copier la page HTML
            copie_jusque_fin ($descfic);

            // page recopiée, on n'a plus besoin du fichier html
            fclose ($descfic);
        }
    }
?>
