<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonctions de génération des menus déroulants
    require ("menus_deroulants.php");

    // Constantes
    require ("dirsite.php");
    define ('PAGE', "choixtrad");



    // génère le morceau de page permettant de définir les langues de traduction

    function genpage_choixtrad ($trad_directe, $lg_source, $lg_cible, $lg_pivot, $suppr_sig, $format)
    {
        // déterminer le suffixe de la page à afficher

        // pour une traduction de texte
        if ($format != "web")
        {
            $bandeau = substr ($_COOKIE ['dispo_tradtxt'], 0, 1);

            // bandeau de sélection horizontal ou vertical ?
            if ($bandeau == "<" || $bandeau == ">")
                $suf = "v";
            else if ($bandeau == "^" || $bandeau == "v")
                $suf = "h1";
            else
                $suf = "h2";
        }
        // pour traduire une page web
        else
        {
            $bandeau = substr ($_COOKIE ['dispo_tradweb'], 0, 1);

            // bandeau de sélection horizontal ou vertical ?
            if ($bandeau == "<" || $bandeau == ">")
                $suf = "v";
            else
                $suf = "h";

            $suf = $suf."_pweb";
        }

        // fabriquer le chemin d'accès à la page à afficher
        $ficpage = DIRPAGE_ML."/".PAGE."_".$suf.".html";

        // si la page cherchée n'existe pas
        if (! file_exists ($ficpage))
        {
            // erreur fatale
            echo msg_chaine ("MANQUE_PAGE", PAGE."_".$suf);
            return;
        }

        // sélectionner la langue de l'interface utilisateur
        $lg_util = choix_langue ();

        // ouvrir le ficher contenant la page à afficher
        $descfic = fopen ($ficpage, "r");

        // si ouverture réussie
        if ($descfic)
        {
            // récupérer la valeur de la case indiquant la traduction directe
            if ($trad_directe != "N")
                // convertir l'information en HTML
                $checked = "checked";
            else
                $checked = "";

            // recopie jusqu'a la case à cocher indiquant la traduction directe
            // initialisation de cette case
            copmaj ($descfic, "XXXCHECK", $checked);

            // recopie jusqu'à la liste des langues sources
            copie_jusque_option ($descfic);

            // générer le menu déroulant des langues sources
            gen_langues_dispo ($lg_source, "t", $lg_util);

            // recopie jusqu'à la liste des langues cibles
            copie_jusque_option ($descfic);

            // si traduction intermédiaire acceptée
            if ($trad_directe == "N")
            {
                // générer le menu déroulant avec toutes les langues cibles disponibles
                gen_langues_dispo ($lg_cible, "t", $lg_util);

                // recopie jusqu'à la liste des langues intermédiaires
                copie_jusque_option ($descfic);

                // générer le menu déroulant avec les langues intermédiaires disponibles
                gen_lg_pivot ($lg_source, $lg_cible, $lg_pivot, "t", $lg_util);
            }
            // sinon
            else
            {
                // générer le menu déroulant avec les langues
                // cibles disponibles pour une traduction directe
                gen_lg_cible_traddir ($lg_source, $lg_cible, "t", $lg_util);

                // recopie jusqu'à la liste des langues intermédiaires
                copie_jusque_chaine ($descfic, "MM_LG_PIVOT");

                // mais laisser ce champ vide
                sauter_jusque_chaine ($descfic, "</form>");

                // si affichage vertical, sauts de lignes pour compenser la place prise
                if ($suf == "v")
                    echo "    <br>\n    <br>\n    <br>\n";
            }

            // si traduction d'une page web
            if ($format == "web")
            {
                // déterminer le sens du bouton de masquage du choix des langues
                if ($_COOKIE ['dispo_tradweb'] == "v")
                    $sens = "b";
                else
                    $sens = "h";

                // affichage de ce bouton
                copmaj ($descfic, "XXXSENS", $sens);
            }

            // récupérer la valeur de la case indiquant si on supprime les = @ #
            if ($suppr_sig != "N")
                // convertir l'information en HTML
                $checked = "checked";
            else
                $checked = "";

            // recopie jusqu'a la case à cocher indiquant la traduction directe
            // initialisation de cette case
            copmaj ($descfic, "XXXCHECK", $checked);

            // si on veut traduire un texte
            if ($format != "web")
            {
                // recopie jusqu'au choix du format des données
                copie_jusque_option ($descfic);

                // générer le menu déroulant de choix d'un format
                gen_formats_texte ($format);
            }

            // terminer la page HTML
            copie_jusque_fin ($descfic);

            // page recopiée, on n'a plus besoin du fichier html
            fclose ($descfic);
        }
    }
?>
