<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonctions d'affichage de l'entête des pages de documentation
    require ("gen_lg_menu.php");

    // Constantes
    require ("dirsite.php");


    // sélectionner la langue de l'interface utilisateur
    $langue = choix_langue ();

    // nom de page passé en paramètre ou page par défaut
    if (isset ($_GET ['page']) && strpos (" ".$_GET ['page'], "/") == 0)
        $page = substr ($_GET ['page'], 0, 15);
    else
        $page = "index";

    $ficpage = DIRPAGES."/".$langue."/".$page.".html";

    // si la page cherchée n'existe pas
    if (! file_exists ($ficpage))
    {
        // essayer de la remplacer par la page d'erreur
        if (file_exists (MANQUE_PAGE))
            $ficpage = MANQUE_PAGE;
        else
        {
            // erreur fatale
            echo msg_chaine ("MANQUE_PAGE", $page);
            return;
        }
    }

    // ouvrir le ficher contenant la page à afficher
    $descfic = fopen ($ficpage, "r");

    // si ouverture réussie
    if ($descfic)
    {
        // copier le début de la page en le corrigeant
        cop_debpage ($descfic);

        // insérer le bandeau des langues
        ajout_langues ();

        // insérer le menu
        ajout_menu ();

        // le menu est à gauche sur la hauteur restante
        echo "    <div id=\"contenu\">\n";

        // si page manquante, mais affichage de la page d'erreur
        if ($ficpage == MANQUE_PAGE)
            // message d'erreur en bas de cette page
            copmaj ($descfic, "MM_MANQUE_PAGE", msg_chaine ("MANQUE_PAGE", $page));

        // copier le reste du corps de la page
        copie_jusque_chaine ($descfic, "</body>");

        // fin de la section et de la page
        echo "    </div>\n";
        echo "</body>\n";

        // copier la fin de la page HTML
        copie_jusque_fin ($descfic);

        // page recopiée, on n'a plus besoin du fichier html
        fclose ($descfic);
    }
?>
