<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // Constantes
    require ("dirsite.php");
    require ("defaut_textarea.php");

    define ('PAGE', "lgmax_url");


    // sélectionner la langue de l'interface utilisateur
    $langue = choix_langue ();

    // page à afficher
    $page = PAGE;
    $ficpage = DIRPAGES."/".$langue."/".$page.".html";

    // si la page cherchée n'existe pas
    if (! file_exists ($ficpage))
    {
        // essayer de la remplacer par la page d'erreur
        if (file_exists (MANQUE_PAGE))
            $ficpage = MANQUE_PAGE;
        else
        {
            // erreur fatale
            echo msg_chaine ("MANQUE_PAGE", $page);
            return;
        }
    }

    // récupérer et mettre à jour la largeur de la barre d'URL

    // largeur suite à l'action sur un bouton de réglage
    if (isset ($_POST ['lg_max']))
    {
        // récupérer $_POST ['lg_max']
        $lg_max_orig = $_POST ['lg_max'];

        // si retour à la valeur par défaut
        if ($lg_max_orig == "defaut")
            // calculer cette valeur à partie du cookie col_saisie
            $lg_max = $_COOKIE ['col_saisie'] - 25;

        // sinon prise en compte de la variation demandée
        else if (isset ($_POST ['depl']))
        {
            $lg_max = $lg_max_orig + $_POST ['depl'];

            // $lg_max_orig sera la valeur sauvée si on accepte ce réglage
            $lg_max_orig = $lg_max;
        }
    }
    // sinon largeur initiale à partir du cookie spécifique
    else if (isset ($_COOKIE ['lgmax_url']))
        $lg_max = $_COOKIE ['lgmax_url'];

    // sinon largeur initiale à partir du cookie col_saisie
    else if (isset ($_COOKIE ['col_saisie']))
        $lg_max = $_COOKIE ['col_saisie'] - 25;

    // dernier cas qui ne devrait jamais arriver (largeur par défaut)
    else
        $lg_max = COLON_DEFAUT - 25;

    // corriger les largeurs hors limite
    if ($lg_max < MIN_LGURL)
        $lg_max = MIN_LGURL;
    else if ($lg_max > MAX_LGURL)
        $lg_max = MAX_LGURL;

    // ouvrir le ficher contenant la page à afficher
    $descfic = fopen ($ficpage, "r");

    // si ouverture réussie
    if ($descfic)
    {
        // mettre à jour la longueur de la barre d'URL partout où elle est mentionnée
        copmaj ($descfic, "XXXLGURL", $lg_max);
        copmaj ($descfic, "XXXLGURL", $lg_max);

        // pour l'enregistrement du réglage possibilité de prendre le calcul par défaut
        copmaj ($descfic, "XXXLGURL", $lg_max_orig);

        // copier la fin de la page HTML
        copie_jusque_fin ($descfic);

        // page recopiée, on n'a plus besoin du fichier html
        fclose ($descfic);
    }
?>
