<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonctions d'affichage de l'entête des pages de documentation
    require ("gen_lg_menu.php");

    // fonction de chargement des préférences depuis un fichier
    require ("recup_pref.php");

    // fonction de sauvegarde des préférences dans un fichier
    require ("sauv_pref.php");

    // Constantes
    require ("dirsite.php");
    require ("defaut_textarea.php");

    define ('PAGE', "pref_affichage");


    // génère un choix de bouton radio

    function gen_bouton_radio ($nomchoix, $message, $valoption, $select)
    {
        echo "          <tr><td><input type=\"radio\" name=\"";
        echo $nomchoix."\" value=\"".$valoption."\" ";

        if ($valoption == $select)
            echo "checked";
        else
            echo "onchange=\"submit()\"";

        echo ">".message ($message)."</td></tr>\n";
    }


    // si demande de récupération de préférences depuis un fichier
    if (isset ($_POST ['charger']))
        // récupérer les préférences enregistrées
        recup_pref ();
    // sinon
    else
    {
        // vérifier l'existence des cookies et si nécessaire les créer avec les
        // valeurs par défaut (cookies valables jusqu'à la sortie du navigateur)

        // mode de détermination de la taille des zones d'affichage
        if (! isset ($taille_auto))
        {
            if (isset ($_COOKIE ['taille_auto']))
                $taille_auto = $_COOKIE ['taille_auto'];
            else
            {
                $taille_auto = "O";
                setcookie ("taille_auto", $taille_auto, 0);
            }
        }

        // structure de la page de traduction des textes
        if (! isset ($posit))
        {
            // position du bandeau de sélection des langues (ou des sens de traduction)
            // et disposition des zones de saisie du texte source et de la traduction
            if (isset ($_COOKIE ['dispo_tradtxt']))
            {
                $posit = substr ($_COOKIE ['dispo_tradtxt'], 0, 1);
                $orient = substr ($_COOKIE ['dispo_tradtxt'], 1);
            }
            else
            {
                // par défaut, bandeau en haut sur 2 lignes
                $posit = POSCHOIXL_DEFAUT;

                // par défaut texte source à gauche, traduction à droite
                $orient = ORIENT_TRAD_DEFAUT;

                // créer le cookie avec les valeurs par défaut
                setcookie ("dispo_tradtxt", $posit.$orient, 0);
            }
        }

        // stucture de la page de traduction des pages web
        if (! isset ($pos_pweb))
        {
            // position du bandeau de sélection des langues (ou des
            // sens de traduction) pour la traductions de pages web
            if (isset ($_COOKIE ['dispo_tradweb']))
                $pos_pweb = $_COOKIE ['dispo_tradweb'];
            else
            {
                // par défaut, bandeau en haut
                $pos_pweb = POSCHOIXPWEB_DEFAUT;

                // créer le cookie avec les valeurs par défaut
                setcookie ("dispo_tradweb", $pos_pweb, 0);
            }
        }
    }


    // sélectionner la langue de l'interface utilisateur
    $langue = choix_langue ();

    // page à afficher
    $page = PAGE;
    $ficpage = DIRPAGES."/".$langue."/".$page.".html";

    // si la page cherchée n'existe pas
    if (! file_exists ($ficpage))
    {
        // essayer de la remplacer par la page d'erreur
        if (file_exists (MANQUE_PAGE))
            $ficpage = MANQUE_PAGE;
        else
        {
            // erreur fatale
            echo msg_chaine ("MANQUE_PAGE", $page);
            return;
        }
    }

    // prendre en compte un changement du mode de
    // détermination de la taille des zones d'affichage
    if (isset ($_POST ['taille_auto']))
    {
        $taille_auto = $_POST ['taille_auto'];
        setcookie ("taille_auto", $taille_auto, 0);
    }
    // il peut avoir été passé par la méthode GET si le mode auto ne marche pas
    else if (isset ($_GET ['taille_auto']))
    {
        // récupérer le premier caractère
        $taille_auto = substr (trim ($_GET ['taille_auto']), 0, 1);

        // mettre à jour le cookie
        if (strtoupper ($taille_auto) == "N")
            setcookie ("taille_auto", "N", 0);
        else
            setcookie ("taille_auto", "O", 0);
    }

    // prendre en compte un changement du choix de position
    // du bandeau de sélection des langues pour les textes
    if (isset ($_POST ['position']))
    {
        $posit = $_POST ['position'];
        setcookie ("dispo_tradtxt", $posit.$orient, 0);
    }

    // prendre en compte un changement d'orientation
    else if (isset ($_POST ['orientation']))
    {
        $orient = $_POST ['orientation'];
        setcookie ("dispo_tradtxt", $posit.$orient, 0);
    }

    // prendre en compte un changement du choix de position
    // du bandeau de sélection des langues pour les pages web
    else if (isset ($_POST ['pos_pweb']))
    {
        $pos_pweb = $_POST ['pos_pweb'];
        setcookie ("dispo_tradweb", $pos_pweb, 0);
    }

    // prendre en compte un changement de la taille de la zone de saisie
    else if (isset ($_POST ['lignes']) || isset ($_POST ['colonnes']))
    {
        // après vérification des valeurs introduites
        if (is_numeric ($_POST ['lignes']))
        {
            $nblig = $_POST ['lignes'];

            // corriger les valeurs trop petites ou trop grandes
            if ($nblig < MIN_LIGNES)
                $nblig = MIN_LIGNES;
            else if ($nblig > MAX_LIGNES)
                $nblig = MAX_LIGNES;

            // mettre à jour le cookie
            setcookie ("lig_saisie", $nblig, 0);
        }

        // même traitement pour le nombre de colonnes
        if (is_numeric ($_POST ['colonnes']))
        {
            $nbcol = $_POST ['colonnes'];

            // corriger les valeurs trop petites ou trop grandes
            if ($nbcol < MIN_COLONS)
                $nbcol = MIN_COLONS;
            else if ($nbcol > MAX_COLONS)
                $nbcol = MAX_COLONS;

            // mettre à jour le cookie
            setcookie ("col_saisie", $nbcol, 0);
        }
    }

    // enregistrement éventuel des préférences dans un fichier
    else if (isset ($_POST ['enregistrer']))
        sauv_pref ();

    // prendre en compte un changement de la taille de la zone de saisie des URL
    else if (isset ($_POST ['lgmax_url']))
    {
        // récupérer la valeur
        $lgmax_url = $_POST ['lgmax_url'];

        // si nouvelle valeur de longueur
        if (is_numeric ($lgmax_url))
            // mettre à jour le cookie
            setcookie ("lgmax_url", $lgmax_url, 0);
        // sinon, si réglage par défaut
        else if ($_POST ['lgmax_url']== "defaut")
            // supprimer le cookie
            setcookie ("lgmax_url", "", 1);
    }

    // initialisations éventuelles si détermination manuelle de la taille d'affichage
    if ($taille_auto == "N")
    {
        // nombre des lignes d'un textarea occupant toute la fenêtre du navigateur
        if (! isset ($nblig))
        {
            if (isset ($_COOKIE ['lig_saisie']))
                $nblig = $_COOKIE ['lig_saisie'];
            else
            {
                $nblig = LIGNE_DEFAUT;
                setcookie ("lig_saisie", $nblig, 0);
            }
        }

        // nombre des colonnes d'un textarea occupant toute la fenêtre du navigateur
        if (! isset ($nbcol))
        {
            if (isset ($_COOKIE ['col_saisie']))
                $nbcol = $_COOKIE ['col_saisie'];
            else
            {
                $nbcol = COLON_DEFAUT;
                setcookie ("col_saisie", $nbcol, 0);
            }
        }
    }


    // ouvrir le ficher contenant la page à afficher
    $descfic = fopen ($ficpage, "r");

    // si ouverture réussie
    if ($descfic)
    {
        // copier le début de la page en le corrigeant
        cop_debpage ($descfic);

        // insérer le bandeau des langues
        ajout_langues ();

        // insérer le menu
        ajout_menu ();

        // le menu est à gauche sur la hauteur restante
        echo "    <div id=\"contenu\">\n";

        // si la page à afficher a été trouvée
        if ($ficpage != MANQUE_PAGE)
        {
            // copier jusqu'à la zone du bouton de chargement des préférences
            copie_jusque_chaine ($descfic, "RECUP_PREF");

            // si des préférence ont déjà été sauvegardées
            if (file_exists (SAUV_PREF))
            {
                // générer le bouton pour les charger
                echo "      <form action=pref_affichage.php method=post>\n";
                echo "          <button type=\"submit\" name=\"charger\" style=\"font-size : 100%\">\n";
                echo "                  ".message ("CHARGE_PREF")."</button>\n";
                echo "      </form>\n";
            }

            // copier jusqu'à la zone de choix du mode de détermination de la taille de la fenêtre
            copie_jusque_chaine ($descfic, "XXXINPUT");

            // générer les boutons radio permettant de choisir
            gen_bouton_radio ("taille_auto", "TAILLE_AUTO","O", $taille_auto);
            gen_bouton_radio ("taille_auto", "TAILLE_FIXE","N", $taille_auto);

            // copie de la fin du formulaire
            copie_jusque_chaine ($descfic, "</form>", 1);

            // si détermination manuelle de la taille
            if ($taille_auto == "N")
            {
                // sauter la partie concernant l'ajustement du mode automatique
                sauter_jusque_chaine ($descfic, "</a>");

                // copier jusqu'à la zone de choix de la taille des zones de saisie
                // et mettre à jour les valeurs des champs "lignes" et "colonnes"
                copmaj ($descfic, "XXXLIGNES", $nblig);
                copmaj ($descfic, "XXXCOLS", $nbcol);
            }
            // sinon
            else
            {
                // copier la partie concernant l'ajustement du mode automatique
                copie_jusque_chaine ($descfic, "</a>", 1);

                // sauter la détermination manuelle
                sauter_jusque_chaine ($descfic, "</a>");
                sauter_jusque_chaine ($descfic, "</a>");
            }

            // copier jusqu'à la zone de choix de la position du bandeau de langues
            copie_jusque_chaine ($descfic, "XXXINPUT");

            // générer la sélection de position par boutons radio
            gen_bouton_radio ("position", "HAUT_2L","A", $posit);
            gen_bouton_radio ("position", "HAUT_1L","^", $posit);
            gen_bouton_radio ("position", "GAUCHE", "<", $posit);
            gen_bouton_radio ("position", "DROITE", ">", $posit);
            gen_bouton_radio ("position", "BAS_1L", "v", $posit);
            gen_bouton_radio ("position", "BAS_2L", "V", $posit);

            // copier jusqu'à la zone de choix de l'orientation de la zone de traduction
            copie_jusque_chaine ($descfic, "XXXINPUT");

            // générer la sélection de position par boutons radio
            gen_bouton_radio ("orientation", "ORIENT_VERT","|", $orient);
            gen_bouton_radio ("orientation", "ORIENT_HORIZ","-", $orient);

            // copier jusqu'à la zone de choix de la position du bandeau de langues
            copie_jusque_chaine ($descfic, "XXXINPUT");

            // générer la sélection de position par boutons radio
            gen_bouton_radio ("pos_pweb", "HAUT",   "^", $pos_pweb);
            gen_bouton_radio ("pos_pweb", "GAUCHE", "<", $pos_pweb);
            gen_bouton_radio ("pos_pweb", "DROITE", ">", $pos_pweb);
            gen_bouton_radio ("pos_pweb", "BAS",    "v", $pos_pweb);
        }
        // sinon
        else
            // message d'erreur en bas de la page de remplacement
            copmaj ($descfic, "MM_MANQUE_PAGE", msg_chaine ("MANQUE_PAGE", PAGE));

        // copier le reste du corps de la page
        copie_jusque_chaine ($descfic, "</body>");

        // fin de la section et de la page
        echo "    </div>\n";
        echo "</body>\n";

        // copier la fin de la page HTML
        copie_jusque_fin ($descfic);

        // page recopiée, on n'a plus besoin du fichier html
        fclose ($descfic);
    }
?>
