<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonctions d'affichage de l'entête des pages de documentation
    require ("gen_lg_menu.php");

    // fonction de chargement des préférences depuis un fichier
    require ("recup_pref.php");

    // fonction de sauvegarde des préférences dans un fichier
    require ("sauv_pref.php");

    // Constantes
    require ("dirsite.php");

    define ('PAGE', "pref_traduct");


    // génère un choix de bouton radio

    function gen_bouton_radio ($nomchoix, $message, $valoption, $select)
    {
        echo "          <tr><td><input type=\"radio\" name=\"";
        echo $nomchoix."\" value=\"".$valoption."\" ";

        if ($valoption == $select)
            echo "checked";
        else
            echo "onchange=\"submit()\"";

        echo ">".message ($message)."</td></tr>\n";
    }


    // si demande de récupération de préférences depuis un fichier
    if (isset ($_POST ['charger']))
        // récupérer les préférences enregistrées
        recup_pref ();
    // sinon
    else
    {
        // vérifier l'existence des cookies et si nécessaire les créer avec les
        // valeurs par défaut (cookies valables jusqu'à la sortie du navigateur)
        if (! isset ($trad_directe))
        {
            if (isset ($_COOKIE ['trad_directe']))
                $trad_directe = $_COOKIE ['trad_directe'];
            else
            {
                $trad_directe = "N";
                setcookie ("trad_directe", $trad_directe, 0);
            }
        }

        if (! isset ($suppr_sig))
        {
            if (isset ($_COOKIE ['suppr_sig']))
                $suppr_sig = $_COOKIE ['suppr_sig'];
            else
            {
                $suppr_sig = "N";
                setcookie ("suppr_sig", $suppr_sig, 0);
            }
        }
    }

    // sélectionner la langue de l'interface utilisateur
    $langue = choix_langue ();

    // page à afficher
    $page = PAGE;
    $ficpage = DIRPAGES."/".$langue."/".$page.".html";

    // si la page cherchée n'existe pas
    if (! file_exists ($ficpage))
    {
        // essayer de la remplacer par la page d'erreur
        if (file_exists (MANQUE_PAGE))
            $ficpage = MANQUE_PAGE;
        else
        {
            // erreur fatale
            echo msg_chaine ("MANQUE_PAGE", $page);
            return;
        }
    }

    // prendre en compte un changement du choix "traduction directe"
    if (isset ($_POST ['trad_dir']))
    {
        $trad_directe = $_POST ['trad_dir'];
        setcookie ("trad_directe", $trad_directe, 0);
    }

    // prendre en compte un changement du choix "supprimmer les * @ et #"
    else if (isset ($_POST ['suppr_sig']))
    {
        $suppr_sig = $_POST ['suppr_sig'];
        setcookie ("suppr_sig", $suppr_sig, 0);
    }

    // enregistrement éventuel des préférences dans un fichier
    else if (isset ($_POST ['enregistrer']))
        sauv_pref ();


    // ouvrir le ficher contenant la page à afficher
    $descfic = fopen ($ficpage, "r");

    // si ouverture réussie
    if ($descfic)
    {
        // copier le début de la page en le corrigeant
        cop_debpage ($descfic);

        // insérer le bandeau des langues
        ajout_langues ();

        // insérer le menu
        ajout_menu ();

        // le menu est à gauche sur la hauteur restante
        echo "    <div id=\"contenu\">\n";

        // si la page à afficher a été trouvée
        if ($ficpage != MANQUE_PAGE)
        {
            // copier jusqu'à la zone du bouton de chargement des préférences
            copie_jusque_chaine ($descfic, "RECUP_PREF");

            // si des préférence ont déjà été sauvegardées
            if (file_exists (SAUV_PREF))
            {
                // générer le bouton pour les charger
                echo "      <form action=pref_traduct.php method=post>\n";
                echo "          <button type=\"submit\" name=\"charger\" style=\"font-size : 100%\">\n";
                echo "                  ".message ("CHARGE_PREF")."</button>\n";
                echo "      </form>\n";
            }

            // copier jusqu'à la zone de choix de la traduction directe ou pas
            copie_jusque_chaine ($descfic, "XXXINPUT");

            // générer le choix des traductions directes par boutons radio
            gen_bouton_radio ("trad_dir", "TRAD_PIVOT_OK","N", $trad_directe);
            gen_bouton_radio ("trad_dir", "TRAD_DIR_SEUL","O", $trad_directe);

            // copier jusqu'à la zone de choix de la suppression des * # @ ou pas
            copie_jusque_chaine ($descfic, "XXXINPUT");

            // générer le choix des suppresssions ou pas par boutons radio
            gen_bouton_radio ("suppr_sig", "GARDE_SIGNES","N", $suppr_sig);
            gen_bouton_radio ("suppr_sig", "SUPPR_SIGNES","O", $suppr_sig);
        }
        // sinon
        else
            // message d'erreur en bas de la page de remplacement
            copmaj ($descfic, "MM_MANQUE_PAGE", msg_chaine ("MANQUE_PAGE", PAGE));

        // copier le reste du corps de la page
        copie_jusque_chaine ($descfic, "</body>");

        // fin de la section et de la page
        echo "    </div>\n";
        echo "</body>\n";

        // copier la fin de la page HTML
        copie_jusque_fin ($descfic);

        // page recopiée, on n'a plus besoin du fichier html
        fclose ($descfic);
    }
?>
