<?php
    // fonction de traduction des mnémoniques
    require ("messages.php");

    // fonctions de traduction
    require ("traduction.php");


    // Constantes
    require ("dirsite.php");
    define ('LGMAX', 200);  // longueur maximale des lignes des fichiers



    // détecter si mode d'affichage de la traduction plein écran modifiable
    if (isset ($_COOKIE ['visib_lg_url']) && $_COOKIE ['visib_lg_url'] == "1")
        $aff_pl = 1;

    // récupérer l'url de la page à traduire
    if (isset ($_COOKIE ['url']))
        $url = $_COOKIE ['url'];

    // pas de traduction si aucune url introduite
    if ($url == "")
    {
        // si mode d'affichage plein écran modifiable
        if ($aff_pl)
            // on pourra revenir dans un autre mode
            readfile (BOUTONS_VIS);

        // rien d'autre à afficher
        return;
    }

    // récupérer le(s) sens de traduction
    $msg_erreur = recup_senstrad ($senstrad);

    // si la récupération s'est mal passée
    if ($msg_erreur != "")
    {
        // si mode d'affichage plein écran modifiable
        if ($aff_pl)
        {
            // on pourra revenir dans un autre mode
            readfile (BOUTONS_VIS);
            echo "<br><br>\n";
        }

        // afficher le message d'erreur
        echo $msg_erreur;

        // on ne continue pas
        return;
    }

    // s'il existe une clé pour éviter les collisions entre
    // plusieurs navigateurs utilisant la même adresse ip
    if (isset ($_COOKIE ['cle_navig']))
        // récupérer cette clé
        $cle = $_COOKIE ['cle_navig'];
    // sinon
    else
    {
        // créer et mémoriser la clé
        $cle = substr (sha1 (time ().$_SERVER ['REMOTE_PORT']), 9, 6);
        setcookie ("cle_navig", $cle, 0);

        // on va en profiter pour nettoyer le répertoire des fichiers temporaires

        // calculer l'heure minimale de conservation à partir de l'heure actuelle
        $heuremin = time () - 600;

        // on va explorer le répertoire où ces fichiers sont mémorisés
        $descdir = opendir (TMPDIR);

        // exploration du répertoire
        while ($fichier = readdir ($descdir))
        {
            // si le fichier n'est pas . ou ..
            if (substr ($fichier, 0, 1) != ".")
            {
                // fabriquer son chemin d'accès
                $chemfic = TMPDIR."/".$fichier;

                // s'il n'a pas été modifié assez récemment
                if (filemtime ($chemfic) < $heuremin)
                    // le détruire
                    unlink ($chemfic);
            }
        }

        // nettoyage effectué
        closedir ($descdir);
    }

    // identificateur de la traduction demandée
    $id_trad = $senstrad.$_COOKIE ['suppr_sig'].$url;

    // nom du fichier pour conserver la dernière traduction demandée
    $fictrad = TMPDIR."/".$_SERVER ['REMOTE_ADDR']."-".$cle;

    // si ce fichier existe déjà
    if (file_exists ($fictrad))
    {
        // lire la première ligne de ce fichier
        $descfic = fopen ($fictrad, "r");

        if ($descfic)
        {
            $ligne = trim (fgets ($descfic, 320));

            // si le fichier contient la traduction demandée
            if ($ligne == $id_trad)
            {
                // afficher directement cette traduction sans la refaire
                $ligne = fgets ($descfic, LGMAX);

                while ($ligne)
                {
                    // si mode d'affichage plein écran modifiable
                    // et on est sur la ligne </body>
                    if ($aff_pl == 1 && stripos ($ligne, "/body>") > 0)
                    {
                        // rajouter les boutons permettant de revenir dans un autre mode
                        readfile (BOUTONS_VIS);

                        // les boutons ont été affichés
                        $aff_pl = 0;
                    }

                    echo $ligne;

                    $ligne = fgets ($descfic, LGMAX);
                }

                // nouvelle tentative d'affichage des boutons
                // dans le cas d'une page web tronquée
                if ($aff_pl == 1)
                    readfile (BOUTONS_VIS);

                // terminé
                fclose ($descfic);
                return;
            }
            // sinon
            else
                // on n'a pas besoin de lire la suite du fichier
                fclose ($descfic);
        }
    }

    // cas général, on n'a pas encore la traduction

    // tenter d'ouvrir l'url
    $descurl = fopen ($url, "r");

    if ($descurl)
    {
        // créer un nom de fichier temporaire
        $ficpage = tempnam (TMPDIR, "pageweb");

        // mettre dans le premier fichier le contenu du texte à traduire
        $descfic = fopen ($ficpage, "w");

        if ($descfic)
        {
            $ligne = fgets ($descurl, LGMAX);

            while ($ligne)
            {
                fputs ($descfic, $ligne);

                $ligne = fgets ($descurl, LGMAX);
            }

            // fichier recopié
            fclose ($descfic);
        }

        // on n'a plus besoin d'accéder à l'url
        fclose ($descurl);

        // pour corriger les liens de la page web, on a besoin
        // de l'adresse du répertoire d'implantation de la page

        // séparer le protocole et l'adresse de la page
        $finprotoc = strpos ($url, "://") + 3;
        $protoc = substr ($url, 0, $finprotoc);
        $adrpage = substr ($url, $finprotoc);

        $derslash =  strrpos ($adrpage, "/");

        // si l'adresse de la page comporte au moins un /
        if ($derslash)
            // ignorer tout ce qui suit le dernier /
            $dirpage = substr ($adrpage, 0, $derslash);
        // sinon
        else
            // prendre l'adresse de la page telle quelle
            $dirpage = $adrpage;

        // corriger les liens de la page web
        exec ("shells/tradpweb ".$protoc.$dirpage." ".$ficpage);

        // fabriquer la commande de traduction
        $commande = "shells/tradtexte";

        // option de suppression des * @ et # apparus dans la traduction
        if ($_COOKIE ['suppr_sig'] != "N")
            $commande = "$commande -d";

        // fichier à traduire et format
        $commande = "$commande $ficpage html $senstrad";

        // effectuer la traduction
        exec ($commande, $texte_trad);

        // effacer le fichier source avec les liens corrigés
        unlink ($ficpage);

        // récupérer le nombre de lignes du texte traduit
        $nb_lignes = count ($texte_trad);

        // afficher ligne par ligne le texte traduit
        for ($i = 0; $i < $nb_lignes; $i++)
        {
            // si mode d'affichage plein écran modifiable et on est sur la ligne </body>
            if ($aff_pl == 1 && stripos ($texte_trad [$i], "/body>") > 0)
            {
                // rajouter les boutons permettant de revenir dans un autre mode
                readfile (BOUTONS_VIS);

                // les boutons ont été affichés
                $aff_pl = 0;
            }

            echo $texte_trad [$i]."\n";
        }

        // nouvelle tentative d'affichage des boutons
        // dans le cas d'une page web tronquée
        if ($aff_pl == 1)
            readfile (BOUTONS_VIS);

        // mémoriser aussi le résultat de la traduction dans un fichier
        $descfic = fopen ($fictrad, "w");

        if ($descfic)
        {
            // identificateur de la traduction
            fputs ($descfic, $id_trad."\n");

            // contenu de la traduction
            for ($i = 0; $i < $nb_lignes; $i++)
                fputs ($descfic, $texte_trad [$i]."\n");
        }

        // fichier prêt
        fclose ($descfic);
    }
    // sinon url non trouvé
    else
    {
        // si mode d'affichage plein écran modifiable
        if ($aff_pl)
        {
            // on pourra revenir dans un autre mode
            readfile (BOUTONS_VIS);
            echo "<br><br>\n";
        }

        // afficher le message d'erreur
        // Problème d'accès à l'URL $url
        echo msg_chaine ("PB_ACCES_URL", $url);
    }
?>
