<?php
    // initialise un cookie dont la valeur reçue par la
    // méthode get est une lettre parmi 2 possibilités

    function test_recup_cookbin ($param, $valtest, $defaut)
    {
        // si le paramètre est fourni par la méthode get
        if (isset ($_GET [$param]))
        {
            // recupérer le premier caractère significatif
            $valeur = trim ($_GET [$param]);
            $valeur = substr ($valeur, 0, 1);

            // le mettre en majuscules
            $valeur = strtoupper ($valeur);

            // si ce n'est pas $valtest (en général N)
            if ($valeur != $valtest)
                // mettre la valeur par défaut (en général O)
                $valeur = $defaut;

            // initialiser ou mettre à jour le cookie
            setcookie ($param, $valeur, 0);

            // retourner la valeur pour affection éventuelle dans une variable
            return ($valeur);
        }
    }


    // initialise un cookie dont la valeur reçue
    // par la méthode get est un entier

    function test_recup_cooknum ($param, $min, $max, $accept_vide = 0)
    {
        // si le paramètre est fourni par la méthode get
        if (isset ($_GET [$param]))
        {
            // recupérer la valeur du paramètre
            $valeur = trim ($_GET [$param]);

            // si valeur non vide
            if ($valeur != "")
            {
                // si le prelier caractère est un -
                if (substr ($valeur, 0, 1) == "-")
                    // il doit être suivi de chiffres
                    $valmaj = "-".preg_replace ("#[^0-9]#", "", substr ($valeur, 1));
                // sinon
                else
                    // il ne faut que des chiffres
                    $valmaj = preg_replace ("#[^0-9]#", "", $valeur);

                // si c'est une valeur entière positive
                if ($valeur == $valmaj)
                {
                    // et qu'elle est dans l'intervalle autorisé
                    if ($min <= $valeur && $valeur <= $max)
                        // initialiser ou mettre à jour le cookie
                        setcookie ($param, $valeur, 0);
                }
            }
            // sinon, si on accepte une valeur vide
            else if ($accept_vide)
                // supprimer le cookie
                setcookie ($param, "", 1);
        }
    }


    // initialise un cookie dont la valeur reçue par la méthode
    // get est une chaine de caractères de longueur limitée

    function test_recup_cookval ($param, $nbcarmax, $accept_vide = 0)
    {
        // si le paramètre est fourni par la méthode get
        if (isset ($_GET [$param]))
        {
            // recupérer la valeur du paramètre
            $valeur = trim ($_GET [$param]);

            // si valeur non vide, pas trop longue et dans espace
            if ($valeur != "")
            {
                // la mettre en minuscules
                $valeur = strtolower ($valeur);

                // on refuse certains caractères spéciaux
                $valmaj = preg_replace ("#[<|>&'\"\$ ]#", "", $valeur);

                // si valeur pas trop longue et aucun caractère interdit
                if (strlen ($valeur) <= $nbcarmax && $valmaj == $valeur)
                {
                    // initialiser ou mettre à jour le cookie
                    setcookie ($param, $valeur, 0);

                    // retourner la valeur
                    return ($valeur);
                }
                // sinon retourner une chaine vide
                else
                    return ("");
            }
            // sinon, si on accepte une valeur vide
            else if ($accept_vide)
            {
                // initialiser ou mettre à jour le cookie
                setcookie ($param, "", 0);

                // retourner la valeur
                return ("");
            }
        }
    }


    // fonction qui récupère les paramètres fournis par la
    // méthode get et initialise les cookies correspondants

    function recup_params_get ()
    {
        // cookies ne pouvant prendre que 2 valeurs
        test_recup_cookbin ("suppr_sig", "N", "O");
        test_recup_cookbin ("trad_directe", "N", "O");

        // cookies prenant une valeur numérique entière
        test_recup_cooknum ("lig_saisie", MIN_LIGNES, MAX_LIGNES);
        test_recup_cooknum ("col_saisie", MIN_COLONS, MAX_COLONS);
        test_recup_cooknum ("lgmax_url", MIN_LGURL, MAX_LGURL, 1);
        test_recup_cooknum ("ajust_h", -20, 20);
        test_recup_cooknum ("ajust_v", -20, 20);

        // autre cookies
        test_recup_cookval ("lg_source", 6);
        test_recup_cookval ("lg_cible", 6);
        test_recup_cookval ("lg_pivot", 6);
        test_recup_cookval ("senstrad1", 15);
        test_recup_cookval ("senstrad2", 15, 1);
    }
?>
