/*
   Programme qui met  jour les liens d'une page web pour la traduire
*/

#include <stdio.h>
#include <string.h>

#define maxcarbal   20

static int  car;
static char site [100];
static char *dirsite;



/* extraction du nom du site */

trt_url (char *url)
{
    int posurl;


    // mmoriser le rpertoire contenant la page web  traduire
    dirsite = url;

    posurl = 0;

    // se positionner aprs le ://
    while (url [posurl] != ':' && url [posurl])
    {
        site [posurl] = url [posurl];
        posurl ++;
    }

    if (url [posurl] == ':')
    {
        site [posurl ++] = '/';
        site [posurl ++] = '/';
    }

    // rechercher le / suivant
    while (url [posurl] != '/' && url [posurl])
    {
        site [posurl] = url [posurl];
        posurl ++;
    }

    // le nom du site se termine avant ce /
    site [posurl] = '\0';
}


/* sauter les caractres entre le = et le dbut d'un lien */

posit_deblien ()
{
    // lire le caractre qui suit le =
    car = getchar ();

    // si c'est un espace ou une tabulation
    if (car == ' ' || car == '\t')
    {
        // afficher un espace
        putchar (' ');

        // et sauter les suivants s'il y en a d'autres
        do
            car = getchar ();
        while (car == ' ' || car == '\t');
    }

    // si on a trouv "
    if (car == '"')
    {
        // l'afficher
        putchar ('"');

        // et passer au caractre suivant
        car = getchar ();
    }
}


/* remplacer les liens relatifs par des liens absolus */

trtlien (char *bal)
{
    char deblien [10];
    int  posdeblien;
    int  i;


    // si le lien commence par un /
    if (car == '/')
        // le transformer en lien absolu depuis la racine du site
        printf ("%s/", site);
    // sinon
    else
    {
        // parcourir et mmoriser le dbut du lien
        posdeblien = 0;

        do
        {
            deblien [posdeblien ++] = car;
            car = getchar ();
        }
        while (car != ':' && car != ' ' && car != '>'
                          && car != '\t' && posdeblien < 10);

        // si on n'a pas trouv de : assez rapidement
        if (car != ':')
            // c'est un lien relatif a remplacer par un lien absolu
            // commencer le lien  la racine du site
            printf ("%s/", dirsite);

        // recopier le lien relatif  la suite
        for (i = 0; i < posdeblien; i++)
            putchar (deblien [i]);

        // sans oublier le tout dernier caractre lu
        putchar (car);

        // la fin ventuelle du lien sera recopie par le programme principal
    }
}


/* affiche un caractre d'un lien aprs conversion pour certains d'entre eux */

aff_car_url (int carac)
{
    if (carac == '?' || carac == '=' || carac == '&' || carac == '%')
        printf ("%%%2x", carac);
    else
        putchar (carac);
}


/* remplacer les liens vers d'autres pages web par des demandes de traduction */

trtlientrad (char *bal)
{
    char deblien [10];
    int  posdeblien;
    int  i;


    // gnrer l'appel  une demande de traduction
    printf ("tradpweb.php?url=");

    // si l'ancien lien commence par un /
    if (car == '/')
        // le transformer en lien absolu depuis la racine du site
        printf ("%s", site);
    // sinon
    else
    {
        // parcourir et mmoriser le dbut du lien
        posdeblien = 0;

        do
        {
            deblien [posdeblien ++] = car;
            car = getchar ();
        }
        while (car != ':' && car != ' ' && car != '>'
                          && car != '\t' && posdeblien < 10);

        // si on n'a pas trouv de : assez rapidement
        if (car != ':')
            // c'est un lien relatif a remplacer par un lien absolu
            // commencer le lien  la racine du site
            printf ("%s/", dirsite);

        // recopier le lien relatif  la suite en changeant certains caractres
        for (i = 0; i < posdeblien; i++)
            aff_car_url (deblien [i]);

        // jusqu' la fin du lien
        while (car != '"' && car != ' ' && car != '>' && car != '\t')
        {
            aff_car_url (car);

            car = getchar ();
        }
    }

    // terminaison propre des url entours de guillemets
    if (car == '"')
    {
        putchar (car);
        car = getchar ();
    }

    // si pas d'autre attribut aprs l'url
    if (car == '>')
    {
        // rajouter le target
        printf (" target=_top>");
    }
    // sinon
    else
        // continuer sans modifier la fin du lien
        putchar (car);
}


/* programme principal */

main (int narg, char **varg)
{
    int  etat;                // etat de l'analyseur
    char balise [maxcarbal];  // partie gauche de la balise courante
    int  posbal;              // position dans la balise


    // rcuprer et traiter l'url
    if (--narg > 0)
        trt_url (varg [1]);

    // accder au fichier si son nom est pass en paramtre
    if (narg > 1)
        freopen (varg [2], "r", stdin);

    // idem pour le fichier rsultat
    if (narg > 2)
        freopen (varg [3], "w", stdout);

    // lire le premier caractre
    car = getchar ();

    etat = 0;

    // tantque non fin de fichier
    while (car != EOF)
    {
        // afficher directement le caractre lu
        putchar (car);

        // selon le caractre
        switch (car)
        {
            // dbut de balise
            case '<' : etat = 1;
                       posbal = 0;
                       break;

            // balise qui ne contient pas de lien
            case '/' :
            case '>' : etat = 0;
                       break;

            // espace ou tabulation
            case ' ' :
            case '\t': // si c'est l'espace aprs un nom de balise
                       if (etat == 1 && posbal > 0)
                       {
                           // le mmoriser s'il n'y a pas plusieurs espaces d'affile
                           if (balise [posbal - 1] != ' ')
                              balise [posbal ++] = ' ';

                           // on va chercher un paramtre pour cette balise
                           etat = 2;
                       }
                       break;

            // valeur d'un paramtre
            case '=' : // si on a trouv le premier paramtre de la balise
                       if (etat == 2)
                       {
                           balise [posbal] = '\0';

                           // si la balise est un lien vers une page web
                           if (strcmp (balise, "a href") == 0)
                           {
                               // se positionner au dbut de ce lien
                               posit_deblien ();

                               // le modifier pour pouvoir en faire une traduction
                               trtlientrad (balise);
                           }
                           // sinon
                           else
                           {
                               // se positionner sur le nom du paramtre
                               while (balise [posbal] != ' ')
                                   posbal --;

                               // si ce paramtre correspond  un autre nom de lien
                               // css, image, video ...
                               if (strcmp (balise + posbal, " src") == 0
                                || strcmp (balise + posbal, " href") == 0)
                               {
                                   // se positionner au dbut de ce lien
                                   posit_deblien ();

                                   // remplacer un lien relatif par un lien absolu
                                   trtlien (balise);
                               }
                           }

                           // fin du traitement pour la balise courante
                           etat = 0;
                       }
                       break;

            // par dfaut si on est dans une balise avant le =
            default  : if (etat == 1 || etat == 2)
                           // mmoriser les caractres lus
                           balise [posbal ++] = tolower (car);
        }

        // si trop de caractres mmoriss sans avoir trouv une balise d'un type cherch
        if (posbal >= maxcarbal)
            // on ignorera cette balise
            etat = 0;

        // lire le caractre suivant
        car = getchar ();
    }
}
