/*
    Fichier supprsig.c
    Auteur Bernard Chardonneau

    Logiciel libre.

    Suppression des symboles * @ et # dans une traduction
    réalisée par Apertium.
*/

#include <stdio.h>



/*
   indique si le caractère correspond à une lettre (ascii non
   accentuée) ou au début d'un code UTF-8 sur plusieurs octets
*/

int lettre (int car)
{
    if (car & 0x80)
        return 1;

    car = car | 0x20;

    return ('a' <= car && car <= 'z');
}


/* indique si le caractère est une lettre ou un chiffre */

int lettrechiffre (int car)
{
    if ('0' <= car && car <= '9')
        return 1;
    else
        return (lettre (car));
}


/* indique si le caractère est * @ ou # */

int symb_spe (int car)
{
    return (car == '*' || car == '@' || car == '#');
}



/* programme principal */

main (int narg, char *varg [])
{
    // caractères précédent, courant et suivant
    int carprec, car, carsuiv;

    // le caractère suivant a-il déjà été lu ?
    int suiv_lu;


    // redirriger les entrées/sorties vers les fichiers passés en paramètre
    if (--narg > 0)
    {
        if (freopen (varg [1], "rb", stdin) == 0)
        {
            fprintf (stderr, "Fichier %s inaccessible ou inexistant\n", varg [1]);
            return;
        }

        if (narg > 1)
        {
            if (freopen (varg [2], "wb", stdout) == 0)
            {
                fprintf (stderr, "Fichier %s protégé en écriture\n", varg [2]);
                return;
            }
        }
    }

    // initialisation
    carprec = '\n';
    car = getchar ();
    suiv_lu = 0;

    // tant que non fin de fichier
    while (car != EOF)
    {
        // si caractères * # ou @ rencontré
        // non précédé d'une lettre ou d'un chiffre
        if (symb_spe (car) && ! lettrechiffre (carprec))
        {
            // lire le caractère suivant
            carsuiv = getchar ();
            suiv_lu = 1;

            // si ce n'est pas une lettre
            if (! lettrechiffre (carsuiv))
                // afficher le caractère * # ou @
                putchar (car);
        }
        // sinon
        else
            // afficher le caractère lu
            putchar (car);

        // le dernier caractère traité devient le caractère précédent
        carprec = car;

        // lire le caractère suivant (qui devient le caractère courant)
        if (suiv_lu)
        {
            car = carsuiv;
            suiv_lu = 0;
        }
        else
            car = getchar ();
    }
}
