<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonctions de traduction
    require ("traduction.php");


    // Constantes
    require ("dirsite.php");
    require ("defaut_textarea.php");

    define ('PAGE', "textetrad");



    // recupérer les préférences de disposition
    if (isset ($_COOKIE ['dispo_tradtxt']))
        $dispo_tradtxt = $_COOKIE ['dispo_tradtxt'];
    else
        // cas dégradé qui ne devrait pas se produire
        $dispo_tradtxt = "A|";

    // choix entre 2 fichiers html pour la zone de saisie et de traduction
    if (substr ($dispo_tradtxt, 1) == "|")
        $suf = "v";
    else
        $suf = "h";

    // fabriquer le chemin d'accès à la page à afficher
    $ficpage = DIRPAGE_ML."/".PAGE."_".$suf.".html";

    // si la page cherchée n'existe pas
    if (! file_exists ($ficpage))
    {
        // erreur fatale
        echo msg_chaine ("MANQUE_PAGE", PAGE);
        return;
    }

    // traitement des zones textarea en fonction l'opération demandée

    // si traduction
    if (isset ($_POST ['traduction']))
    {
        // mémoriser le texte source en remplaçant les ~u par ŭ pour l'esperanto
        $texte_source = str_replace ("~u", "ŭ", $_POST ['texte_source']);

        // s'il y a au moins une balise </textarea> dans le texte source
        if (stripos ($texte_source, "</textarea>") > 0)
        {
            // la transformer pour éviter des gros problèmes d'affichage
            $texte_source = str_replace ("</TEXTAREA>", "&LT;/TEXTAREA>", $texte_source);
            $texte_source = str_replace ("</textarea>", "&lt;/textarea>", $texte_source);
        }

        // récupérer le(s) sens de traduction
        $msg_erreur = recup_senstrad ($senstrad);

        // si la récupération s'est bien passée
        if ($msg_erreur == "")
            // traduire le texte
            $texte_trad = traduction ($texte_source, $senstrad);
        // sinon
        else
            // on affichera le message d'erreur
            $texte_trad [0] = $msg_erreur;
    }
    // sinon si recopie du texte traduit comme texte source
    else if (isset ($_POST ['permute']))
    {
        // recopier le texte traduit comme nouveau texte source
        $texte_source = $_POST ['texte_cible'];

        // pas encore de texte traduit
        $texte_trad = "";
    }
    // sinon effacement demandé ou script relancé sans passer par la méthode POST
    else
    {
        // effacer le texte source et le texte traduit
        $texte_source = "";
        $texte_trad = "";
    }

    // taille d'une zone de saisie occupant toute la fenêtre du navigateur

    // si détermination automatique par javascript activée
    if ($_COOKIE ['taille_auto'] != "N")
    {
        // tenter de récupérer la hauteur de la fenêtre
        if (isset ($_COOKIE ['hauteur']))
        {
            $nbpix = $_COOKIE ['hauteur'];

            // appliquer éventuellement le coefficient correcteur
            if (isset ($_COOKIE ['ajust_v']))
                $nbpix = $nbpix * (1 + ($_COOKIE ['ajust_v'] / 100));

            // convertir en nombre de lignes d'une zone textarea couvrant la page
            $nblig = $nbpix / PIX_LIGNE;
        }

        // et sa largeur
        if (isset ($_COOKIE ['largeur']))
        {
            $nbpix = $_COOKIE ['largeur'];

            // appliquer éventuellement le coefficient correcteur
            if (isset ($_COOKIE ['ajust_h']))
                $nbpix = $nbpix * (1 + ($_COOKIE ['ajust_h'] / 100));

            // convertir en nombre de lignes d'une zone textarea couvrant la page
            $nbcol = $nbpix / PIX_COLONNE;
        }
    }

    // si nombre de lignes non encore récupéré
    if (!isset ($nblig))
    {
        // tenter de le récupérer à partir du cookie pour la mode manuel
        if (isset ($_COOKIE ['lig_saisie']))
            $nblig = $_COOKIE ['lig_saisie'];
        // si le cookie n'existait pas
        else
        {
            // choisir et mémoriser le nombre de lignes par défaut
            $nblig = LIGNE_DEFAUT;
            setcookie ("lig_saisie", $nblig, 0);
        }
    }

    // si nombre de colonnes non encore récupéré
    if (!isset ($nbcol))
    {
        // tenter de le récupérer à partir du cookie pour la mode manuel
        if (isset ($_COOKIE ['col_saisie']))
            $nbcol = $_COOKIE ['col_saisie'];
        // si le cookie n'existait pas
        else
        {
            // choisir et mémoriser le nombre de colonnes par défaut
            $nbcol = COLON_DEFAUT;
            setcookie ("col_saisie", $nbcol, 0);
        }
    }

    // on va déterminer la taille des zones texarea de saisie et de traduction
    switch ($dispo_tradtxt)
    {
        case "A|" :
        case "V|" : $nblig = $nblig - 10;
                    $nbcol = ($nbcol / 2) - 10;
                    break;

        case "^|" :
        case "v|" : $nblig = $nblig - 6;
                    $nbcol = ($nbcol / 2) - 10;
                    break;

        case "<|" :
        case ">|" : $nblig = $nblig - 3;
                    $nbcol = ($nbcol / 2) - 20;
                    break;

        case "A-" :
        case "V-" : $nblig = ($nblig / 2) - 8;
                    $nbcol = $nbcol - 4;
                    break;

        case "^-" :
        case "v-" : $nblig = ($nblig / 2) - 6;
                    $nbcol = $nbcol - 4;
                    break;

        case "<-" :
        case ">-" : $nblig = ($nblig / 2) - 4;
                    $nbcol = $nbcol - 25;
    }

    // arrondis par défaut si nécessaire
    $nblig = floor ($nblig);
    $nbcol = floor ($nbcol);

    // on va générer la nouvelle version de ce morceau de page

    // ouvrir le ficher contenant la page à afficher
    $descfic = fopen ($ficpage, "r");

    // si ouverture réussie
    if ($descfic)
    {
        // copie du fichier HTML jusqu'au début de la zone du texte source
        $ligne = copie_jusque_chaine ($descfic, "<textarea", 1);

        // lecture de la ligne suivante
        $ligne = fgets ($descfic, LGMAX);

        // mettre à jour la taille de la zone textarea
        $ligne = str_replace ("XXXCOLS",   $nbcol, $ligne);
        $ligne = str_replace ("XXXLIGNES", $nblig, $ligne);

        // y ajouter le texte source et afficher cette ligne
        echo str_replace ("</textarea>", $texte_source."</textarea>", $ligne);

        // si la hauteur de la zone d'affichage est faible
        // et boutons de la zone de saisi disposés verticalement
        if ($nblig <= 20 && $suf == "v")
        {
            // initialisation chaine pour enlever des balises <br>
            $chainebr = " <br>";

            // lignes manquantes pour un affichage normal
            $manquant = 20 - $nblig;

            // tant qu'il y a trop de lignes manquantes
            while ($manquant > 2)
            {
                // rapoter un <br> à enlever
                $chainebr = $chainebr."<br>";

                // recalculer les lignes manquantes après cette correction
                $manquant = $manquant - 3;
            }

            // répéter 3 fois
            for ($i = 0; $i < 3 ; $i++)
            {
                // copier le fichier HTML jusqu'à la ligne contenant plusieurs <br> exclue
                $ligne = copie_jusque_chaine ($descfic, "<br><br>");

                // copier la ligne des <br> après en avoir enlevé
                echo str_replace ($chainebr, " ", $ligne);
            }
        }

        // copie du fichier HTML jusqu'au début de la zone du texte traduit
        $ligne = copie_jusque_chaine ($descfic, "<textarea", 1);

        // lecture de la ligne suivante
        $ligne = fgets ($descfic, LGMAX);

        // mettre à jour la taille de la zone textarea
        $ligne = str_replace ("XXXCOLS",   $nbcol, $ligne);
        $ligne = str_replace ("XXXLIGNES", $nblig, $ligne);

        // récupérer le nombre de lignes du texte traduit
        $nb_lignes = count ($texte_trad);

        // si texte traduit non vide
        if ($nb_lignes)
        {
            // générer la zone textarea
            echo str_replace ("</textarea>", $texte_trad [0], $ligne);

            // en copiant ligne par ligne le texte traduit
            for ($i = 1; $i < $nb_lignes; $i++)
                echo $texte_trad [$i]."\n";

            // fin de la zone contenant le texte traduit
            echo "          </textarea>\n";
        }
        // sinon
        else
            // la zone textarea est vide
            echo $ligne;

        // terminer la page HTML
        copie_jusque_fin ($descfic);

        // page recopiée, on n'a plus besoin du fichier html
        fclose ($descfic);
    }
?>
