<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonction de chargement des préférences depuis un fichier
    require ("recup_pref.php");

    // fonctions de récupération de paramètres par la méthode get
    require ("recup_params.php");

    // Constantes
    require ("dirsite.php");
    require ("defaut_textarea.php");

    define ('PAGE', "tradpweb_");


    // si nouvel url passé par la méthode get (clic depuis une page traduite)
    if (isset ($_GET ['url']))
        // prendre en compte cet url
        $url = trim ($_GET ['url']);

    // sinon même chose pour les url passés par la méthode post
    else if (isset ($_POST ['url']))
        $url = trim ($_POST ['url']);

    // si on u récupéré un nouvel url
    if (isset ($url))
    {
        // le faire précéder de http:// si nécessaire
        if (strpos ($url, "://") == 0 && $url != "")
            $url = "http://".$url;

        // mémoriser cet url
        setcookie ("url", $url, 0);
    }

    // si position du bandeau de choix des langues choisie
    if (isset ($_COOKIE ['dispo_tradweb']))
        // la récupérer
        $posit = $_COOKIE ['dispo_tradweb'];

    // sinon si préférences enregistrées
    else if (file_exists (SAUV_PREF))
        // les récupérer
        recup_pref ();
    // sinon
    else
    {
        // par défaut, bandeau en haut sur 2 lignes
        $posit = POSCHOIXPWEB_DEFAUT;

        // créer le cookie avec les valeurs par défaut
        setcookie ("dispo_tradweb", $posit, 0);
    }

    // si position du bandeau de choix des langues passé par la méthode get
    if (isset ($_GET ['dispo_tradweb']))
    {
        // récupérer cette position
        $pos = $_GET ['dispo_tradweb'];

        // si elle a une valeur autorisée
        if ($pos == "^" || $pos == "v" || $pos == "<" || $pos == ">")
        {
            // la prendre en compte
            $posit = $pos;

            // et mettre à jour le cookie qui la mémorise
            setcookie ("dispo_tradweb", $posit, 0);
        }
    }

    // si changement de visibilité du bandeau de sélection des langues et de l'url
    if (isset ($_GET ['visib']))
    {
        // mémoriser la nouvelle valeur
        $vis = $_GET ['visib'];

        // si la nouvelle valeur de visibilité est correcte
        if ($vis == "0" || $vis == "1" || $vis == "2" || $vis == "3")
        {
            // la prendre et la mémoriser
            $visib = $vis;
            setcookie ("visib_lg_url", $visib, 0);
        }
    }

    // si visibilité non déterminée à l'étape précédente
    if (!isset ($visib))
    {
        // si elle est mémorisée dans un cookie
        if (isset ($_COOKIE ['visib_lg_url']))
            // la récupérer
            $visib = $_COOKIE ['visib_lg_url'];
        // sinon
        else
        {
            // par défaut, bandeau de sélection des langues et url tous deux visibles
            $visib = "3";
            setcookie ("visib_lg_url", $visib, 0);
        }
    }

    // chercher le suffixe du fichier html adapté à la position du bandeau
    switch ($visib)
    {
        // traduction plein écran
        case "0" :
        case "1" : $suf = "1";
                   break;

        // affichage seulement du bandeau de l'url et de la traduction
        case "2" : if ($posit == "v")
                       $suf = "2b";
                   else
                       $suf = "2h";
                   break;

        // bandeau de sélection des langues et url tous deux affichés
        default  : switch ($posit)
                   {
                       case "<" : $suf = "3g";
                                  break;
                       case ">" : $suf = "3d";
                                  break;
                       case "v" : $suf = "3b";
                                  break;
                       default  : $suf = "3h";
                   }
    }

    // si mode de récupération de la taille de la fenêtre passé par la méthode get
    if (isset ($_GET ['taille_auto']) && $_GET ['taille_auto'] != "")
        // le mémoriser (et l'enregistrer dans un cookie)
        $taille_auto = test_recup_cookbin ("taille_auto", "N", "O");

    // sinon si mode de récupération de la taille de la fenêtre inconnu
    else if (!isset ($taille_auto))
    {
        // récupérer l'information dans la cookie concerné
        if (isset ($_COOKIE ['taille_auto']))
            $taille_auto = $_COOKIE ['taille_auto'];
        // si ce cookie n'existait pas
        else
        {
            // choisir le mode de récupération automatique
            $taille_auto = "O";

            // et le mémoriser
            setcookie ("taille_auto", "O", 0);
        }
    }

    // type de traduction = page web
    setcookie ("format", "web", 0);

    // si mode de sélection de la traduction passé par la méthode get
    if (isset ($_GET ['mode_sel']) && $_GET ['mode_sel'] != "")
        // le mémoriser (et l'enregistrer dans un cookie)
        $mode_sel = test_recup_cookbin ("mode_sel", "L", "S");

    // récupérer les autres paramètres passés par la méthode get
    recup_params_get ();

    // fabriquer le chemin d'accès à la page à afficher
    $ficpage = DIRPAGE_ML."/".PAGE.$suf.".html";

    // si une langue a été choisie par la méthode get
    if (isset ($_GET ['lang']))
        // la prendre en compte
        choix_langue ();

    // si la page cherchée existe
    if (file_exists ($ficpage))
    {
        // ouvrir le ficher contenant la page à afficher
        $descfic = fopen ($ficpage, "r");

        // si ouverture réussie
        if ($descfic)
        {
            // si détermination automatique de la taille de la fenêtre
            if ($taille_auto != "N")
                ajout_det_taille ($descfic);

            // copier la fin de la page HTML
            copie_jusque_fin ($descfic);

            // page recopiée, on n'a plus besoin du fichier html
            fclose ($descfic);
        }
    }
    // sinon
    else
        // message d'erreur
        echo msg_chaine ("MANQUE_PAGE", PAGE.$suf);
?>
