<?php
    // fonctions d'affichage de portions de pages HTML
    require ("acces_page.php");

    // fonction de chargement des préférences depuis un fichier
    require ("recup_pref.php");

    // fonctions de récupération de paramètres par la méthode get
    require ("recup_params.php");

    // Constantes
    require ("dirsite.php");
    require ("defaut_textarea.php");

    define ('PAGE', "tradtexte");



    // si position du bandeau de choix des langues choisie
    if (isset ($_COOKIE ['dispo_tradtxt']))
        // la récupérer
        $posit = substr ($_COOKIE ['dispo_tradtxt'], 0, 1);

    // sinon si préférences enregistrées
    else if (file_exists (SAUV_PREF))
        // les récupérer
        recup_pref ();
    // sinon
    else
    {
        // par défaut, bandeau en haut sur 2 lignes
        $posit = POSCHOIXL_DEFAUT;

        // par défaut texte source à gauche, traduction à droite
        $orient = ORIENT_TRAD_DEFAUT;

        // créer le cookie avec les valeurs par défaut
        setcookie ("dispo_tradtxt", $posit.$orient, 0);
    }

    // si position du bandeau de choix des langues et
    // des zones de texte passés par la méthode get
    if (isset ($_GET ['dispo_tradtxt']))
    {
        // récupérer ces 2 informations
        $pos = substr ($_GET ['dispo_tradtxt'], 0, 1);
        $orient = substr ($_GET ['dispo_tradtxt'], 1, 1);

        // si ces 2 informations ont des valeurs autorisées
        if (strpos (" <>^vAV", $pos) > 0 && ($orient == "|" || $orient == "-"))
        {
            // prendre en compte la position du bandeau de choix des langues
            $posit = $pos;

            // mettre à jour le cookie mémorisant les 2 informations
            setcookie ("dispo_tradtxt", $posit.$orient, 0);
        }
    }

    // chercher le suffixe du fichier html adapté à la position du bandeau
    switch ($posit)
    {
        case "<" : $suf = "g";
                   break;
        case ">" : $suf = "d";
                   break;
        case "^" : $suf = "h1";
                   break;
        case "v" : $suf = "b1";
                   break;
        case "V" : $suf = "b2";
                   break;
        default  : $suf = "h2";
    }

    // si mode de récupération de la taille de la fenêtre passé par la méthode get
    if (isset ($_GET ['taille_auto']) && $_GET ['taille_auto'] != "")
        // le mémoriser (et l'enregistrer dans un cookie)
        $taille_auto = test_recup_cookbin ("taille_auto", "N", "O");

    // sinon si mode de récupération de la taille de la fenêtre inconnu
    else if (!isset ($taille_auto))
    {
        // récupérer l'information dans la cookie concerné
        if (isset ($_COOKIE ['taille_auto']))
            $taille_auto = $_COOKIE ['taille_auto'];
        // si ce cookie n'existait pas
        else
        {
            // choisir le mode de récupération automatique
            $taille_auto = "O";

            // et le mémoriser
            setcookie ("taille_auto", "O", 0);
        }
    }

    // si format du texte à traduire passé par la méthode get
    if (isset ($_GET ['format']))
    {
        // le récupérer
        $format = test_recup_cookval ("format", 9);

        // et le mémoriser dans un cookie
        setcookie ("format", $format, 0);
    }
    // sinon si format du texte à traduire enregistré dans un cookie
    else if (isset ($_COOKIE ['format']))
        // le récupérer
        $format = $_COOKIE ['format'];

    // si le format récupéré est vide ou celui d'une page web
    if ($format == "web" || $format == "")
        // mémoriser le format texte à la place
        setcookie ("format", "txt", 0);

    // si mode de sélection de la traduction passé par la méthode get
    if (isset ($_GET ['mode_sel']) && $_GET ['mode_sel'] != "")
        // le mémoriser (et l'enregistrer dans un cookie)
        $mode_sel = test_recup_cookbin ("mode_sel", "L", "S");

    // sinon s'il est mémorisé dans un cookie
    else if (isset ($_COOKIE ['mode_sel']))
        // le récupérer
        $mode_sel = $_COOKIE ['mode_sel'];

    // récupérer les autres paramètres passés par la méthode get
    recup_params_get ();

    // fabriquer le chemin d'accès à la page à afficher
    $ficpage = DIRPAGE_ML."/".PAGE."_".$suf.".html";

    // si une langue a été choisie par la méthode get
    if (isset ($_GET ['lang']))
        // la prendre en compte
        choix_langue ();

    // si la page cherchée existe
    if (file_exists ($ficpage))
    {
        // ouvrir le ficher contenant la page à afficher
        $descfic = fopen ($ficpage, "r");

        // si ouverture réussie
        if ($descfic)
        {
            // si détermination automatique de la taille de la fenêtre
            if ($taille_auto != "N")
                // générer les scripts de récupération de la taille
                ajout_det_taille ($descfic);

            // si saisie des sens de traduction plutôt que des langues
            if ($mode_sel == "S")
                // on corrige le nom d'un script appelé dans le frameset
                copmaj ($descfic, "choixtrad.php", "choixsenstrad.php");

            // copier la fin de la page HTML
            copie_jusque_fin ($descfic);

            // page recopiée, on n'a plus besoin du fichier html
            fclose ($descfic);
        }
    }
    // sinon
    else
        // message d'erreur
        echo msg_chaine ("MANQUE_PAGE", PAGE."_".$suf);
?>
