<?php
    // récupération du/des sens de traduction

    function recup_senstrad (&$senstrad)
    {
        // si sélection par langues
        if ($_COOKIE ['mode_sel'] != "S")
        {
            // recupérer les valeurs des cookies de langues dans des variables locales
            $langue_source = $_COOKIE ['lg_source'];
            $langue_cible  = $_COOKIE ['lg_cible'];
            $langue_pivot  = $_COOKIE ['lg_pivot'];

            // élimination de quelques cas triviaux
            if ($langue_source == "")
                // langue du texte source non spécifiée
                return message ("LG_SOURCE_INCONNUE");

            if ($langue_cible == "")
                // langue de la traduction non spécifiée
                return message ("LG_CIBLE_INCONNUE");

            // récupérer les paramètres d'apertium pour le(s) sens de traduction demandé(s)
            $ficsenstrad = DIRLANGUES."/senstrad_t";

            if (! file_exists ($ficsenstrad))
                // erreur fatale
                return msg_chaine ("MANQUE_FICH", basename ($ficsenstrad));

            // ouvrir le fichier contenant la liste des sens de traduction
            $descfic = fopen ($ficsenstrad, "r");

            // si traduction directe
            if ($_COOKIE ['trad_directe'] != "N" || $langue_pivot == "direct")
            {
                // lire la première ligne du fichier des sens de traduction
                $ligne = trim (fgets ($descfic, LGMAX));

                // tant que non fin de fichier et sens de traduction non trouvé
                while ($ligne && ! isset ($senstrad))
                {
                    // récupérer le code de la langue source
                    $separation = strpos ($ligne, " ");
                    $code_lg_source = substr ($ligne, 0, $separation);

                    // si c'est la langue source qu'on cherche
                    if ($code_lg_source == $langue_source)
                    {
                        // récupérer le code de la langue cible
                        $ligne = trim (substr ($ligne, $separation + 1));
                        $separation = strpos ($ligne, " ");
                        $code_lg_cible = substr ($ligne, 0, $separation);

                        // si c'est la langue cible qu'on cherche
                        if ($code_lg_cible == $langue_cible)
                            // récupérer le code du sens de traduction
                            $senstrad = trim (substr ($ligne, $separation + 1));
                    }

                    // lire la ligne suivante du fichier des sens de traduction
                    $ligne = trim (fgets ($descfic, LGMAX));
                }

                // terminé avec ce fichier
                fclose ($descfic);

                // erreur système qui ne devrait jamais se produire
                if (! isset ($senstrad))
                    // Problème de prise en compte du sens de traduction
                    return msg_chaine ("PB_SENS_TRAD", "");
            }
            // sinon traduction avec langue intermédiaire
            else
            {
                // lire la première ligne du fichier des sens de traduction
                $ligne = trim (fgets ($descfic, LGMAX));

                // tant que non fin de fichier et sens de traduction non trouvé
                while ($ligne && (! isset ($senstrad1) || ! isset ($senstrad2)))
                {
                    // récupérer le code de la langue source et de la langue cible
                    $separation = strpos ($ligne, " ");
                    $code_lg_source = substr ($ligne, 0, $separation);
                    $ligne = trim (substr ($ligne, $separation + 1));
                    $separation = strpos ($ligne, " ");
                    $code_lg_cible = substr ($ligne, 0, $separation);

                    // si c'est la langue source et la langue intermédiaire qu'on cherche
                    if ($code_lg_source == $langue_source && $code_lg_cible == $langue_pivot)
                        // récupérer le code du premier sens de traduction
                        $senstrad1 = trim (substr ($ligne, $separation + 1));

                    // sinon si c'est la langue intermédiaire et la langue cible qu'on cherche
                    else if ($code_lg_source == $langue_pivot && $code_lg_cible == $langue_cible)
                        // récupérer le code du deuxième sens de traduction
                        $senstrad2 = trim (substr ($ligne, $separation + 1));

                    // lire la ligne suivante du fichier des sens de traduction
                    $ligne = trim (fgets ($descfic, LGMAX));
                }

                // terminé avec ce fichier
                fclose ($descfic);

                // erreurs système qui ne devraient jamais se produire
                if (! isset ($senstrad1))
                    // Problème de prise en compte du sens de traduction 1
                    return msg_chaine ("PB_SENS_TRAD", "1");

                if (! isset ($senstrad2))
                    // Problème de prise en compte du sens de traduction 2
                    return msg_chaine ("PB_SENS_TRAD", "2");

                // regrouper les 2 sens de traduction
                $senstrad = $senstrad1." ".$senstrad2;
            }
        }
        // sinon saisie directe des sens de traduction
        else
        {
            // élimination directe d'un cas trivial
            if ($_COOKIE ['senstrad1'] == "")
                // Problème de prise en compte du sens de traduction 1
                return msg_chaine ("PB_SENS_TRAD", "1");

            // recupérer le premier sens de traduction
            $senstrad = $_COOKIE ['senstrad1'];

            // rajouter le second sens de traduction s'il existe
            if ($_COOKIE ['senstrad2'] != "")
                $senstrad = $senstrad." ".$_COOKIE ['senstrad2'];
        }
    }


    // traduction du texte passé en paramètre

    function traduction ($texte_source, $senstrad)
    {
        // texte à traduire vide !!!
        if (trim ($texte_source) == "")
            return ("");

        // créer un nom de fichier temporaire
        $ficsource = tempnam (TMPDIR, "texte");
        $descfic = fopen ($ficsource, "w");

        // si la création du fichier s'est bien passée
        if ($descfic)
        {
            // y mettre le contenu du texte à traduire
            fwrite ($descfic, $texte_source);
            fclose ($descfic);

            // fabriquer la commande de traduction
            $commande = "shells/tradtexte";

            // option de suppression des * @ et # apparus dans la traduction
            if ($_COOKIE ['suppr_sig'] != "N")
                $commande = "$commande -d";

            // récupérer le format des données à traduire
            $format = $_COOKIE ['format'];

            // si on vient juste de traduire une page web dans un autre onglet
            if ($format == "web")
            {
                // corriger le format
                $format = "txt";
                setcookie ("format", $format, 0);
            }

            // fichier à traduire et format
            $commande = "$commande $ficsource $format $senstrad";

            // effectuer la traduction
            exec ($commande, $texte_trad);

            // effacer le fichier source de travail
            unlink ($ficsource);
        }

        // retourner le texte traduit
        return $texte_trad;
    }
?>
